# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListBuildAuthTokenResult',
    'AwaitableListBuildAuthTokenResult',
    'list_build_auth_token',
    'list_build_auth_token_output',
]

@pulumi.output_type
class ListBuildAuthTokenResult:
    """
    Build Auth Token.
    """
    def __init__(__self__, expires=None, token=None):
        if expires and not isinstance(expires, str):
            raise TypeError("Expected argument 'expires' to be a str")
        pulumi.set(__self__, "expires", expires)
        if token and not isinstance(token, str):
            raise TypeError("Expected argument 'token' to be a str")
        pulumi.set(__self__, "token", token)

    @property
    @pulumi.getter
    def expires(self) -> str:
        """
        Token expiration date.
        """
        return pulumi.get(self, "expires")

    @property
    @pulumi.getter
    def token(self) -> str:
        """
        Authentication token.
        """
        return pulumi.get(self, "token")


class AwaitableListBuildAuthTokenResult(ListBuildAuthTokenResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListBuildAuthTokenResult(
            expires=self.expires,
            token=self.token)


def list_build_auth_token(build_name: Optional[str] = None,
                          builder_name: Optional[str] = None,
                          resource_group_name: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListBuildAuthTokenResult:
    """
    Gets the token used to connect to the endpoint where source code can be uploaded for a build.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str build_name: The name of a build.
    :param str builder_name: The name of the builder.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['buildName'] = build_name
    __args__['builderName'] = builder_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:app:listBuildAuthToken', __args__, opts=opts, typ=ListBuildAuthTokenResult).value

    return AwaitableListBuildAuthTokenResult(
        expires=pulumi.get(__ret__, 'expires'),
        token=pulumi.get(__ret__, 'token'))
def list_build_auth_token_output(build_name: Optional[pulumi.Input[str]] = None,
                                 builder_name: Optional[pulumi.Input[str]] = None,
                                 resource_group_name: Optional[pulumi.Input[str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListBuildAuthTokenResult]:
    """
    Gets the token used to connect to the endpoint where source code can be uploaded for a build.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str build_name: The name of a build.
    :param str builder_name: The name of the builder.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['buildName'] = build_name
    __args__['builderName'] = builder_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:app:listBuildAuthToken', __args__, opts=opts, typ=ListBuildAuthTokenResult)
    return __ret__.apply(lambda __response__: ListBuildAuthTokenResult(
        expires=pulumi.get(__response__, 'expires'),
        token=pulumi.get(__response__, 'token')))
