# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccessReviewRecurrencePatternType',
    'AccessReviewRecurrenceRangeType',
    'AccessReviewResult',
    'ApprovalMode',
    'AssignmentScopeValidation',
    'AssignmentType',
    'DefaultDecisionType',
    'EnablementRules',
    'EnforcementMode',
    'ExcludedPrincipalTypes',
    'ExemptionCategory',
    'LockLevel',
    'NotificationDeliveryMechanism',
    'NotificationLevel',
    'OverrideKind',
    'PIMOnlyMode',
    'ParameterType',
    'PolicyType',
    'PrincipalType',
    'PublicNetworkAccessOptions',
    'RecipientType',
    'RequestType',
    'ResourceIdentityType',
    'RoleManagementPolicyRuleType',
    'SelectorKind',
    'Type',
    'UserType',
]


class AccessReviewRecurrencePatternType(str, Enum):
    """
    The recurrence type : weekly, monthly, etc.
    """
    WEEKLY = "weekly"
    ABSOLUTE_MONTHLY = "absoluteMonthly"


class AccessReviewRecurrenceRangeType(str, Enum):
    """
    The recurrence range type. The possible values are: endDate, noEnd, numbered.
    """
    END_DATE = "endDate"
    NO_END = "noEnd"
    NUMBERED = "numbered"


class AccessReviewResult(str, Enum):
    """
    Represents a reviewer's decision for a given review
    """
    APPROVE = "Approve"
    DENY = "Deny"
    NOT_REVIEWED = "NotReviewed"
    DONT_KNOW = "DontKnow"
    NOT_NOTIFIED = "NotNotified"


class ApprovalMode(str, Enum):
    """
    The type of rule
    """
    SINGLE_STAGE = "SingleStage"
    SERIAL = "Serial"
    PARALLEL = "Parallel"
    NO_APPROVAL = "NoApproval"


class AssignmentScopeValidation(str, Enum):
    """
    The option whether validate the exemption is at or under the assignment scope.
    """
    DEFAULT = "Default"
    """
    This option will validate the exemption is at or under the assignment scope.
    """
    DO_NOT_VALIDATE = "DoNotValidate"
    """
    This option will bypass the validation the exemption scope is at or under the policy assignment scope.
    """


class AssignmentType(str, Enum):
    """
    The type of policy assignment. Possible values are NotSpecified, System, SystemHidden, and Custom. Immutable.
    """
    NOT_SPECIFIED = "NotSpecified"
    SYSTEM = "System"
    SYSTEM_HIDDEN = "SystemHidden"
    CUSTOM = "Custom"


class DefaultDecisionType(str, Enum):
    """
    This specifies the behavior for the autoReview feature when an access review completes.
    """
    APPROVE = "Approve"
    DENY = "Deny"
    RECOMMENDATION = "Recommendation"


class EnablementRules(str, Enum):
    """
    The type of enablement rule
    """
    MULTI_FACTOR_AUTHENTICATION = "MultiFactorAuthentication"
    JUSTIFICATION = "Justification"
    TICKETING = "Ticketing"


class EnforcementMode(str, Enum):
    """
    The policy assignment enforcement mode. Possible values are Default, DoNotEnforce, and Enroll
    """
    DEFAULT = "Default"
    """
    The policy effect is enforced during resource creation or update.
    """
    DO_NOT_ENFORCE = "DoNotEnforce"
    """
    The policy effect is not enforced during resource creation or update.
    """
    ENROLL = "Enroll"
    """
    The policy effect is not enforced during resource creation or update until the resource or scope of the resource is enrolled to the assignment instance. Enrollment occurs upon deployment of the policy enrollment resource.
    """


class ExcludedPrincipalTypes(str, Enum):
    SERVICE_PRINCIPALS_AS_TARGET = "ServicePrincipalsAsTarget"
    SERVICE_PRINCIPALS_AS_REQUESTOR = "ServicePrincipalsAsRequestor"


class ExemptionCategory(str, Enum):
    """
    The policy exemption category. Possible values are Waiver and Mitigated.
    """
    WAIVER = "Waiver"
    """
    This category of exemptions usually means the scope is not applicable for the policy.
    """
    MITIGATED = "Mitigated"
    """
    This category of exemptions usually means the mitigation actions have been applied to the scope.
    """


class LockLevel(str, Enum):
    """
    The level of the lock. Possible values are: NotSpecified, CanNotDelete, ReadOnly. CanNotDelete means authorized users are able to read and modify the resources, but not delete. ReadOnly means authorized users can only read from a resource, but they can't modify or delete it.
    """
    NOT_SPECIFIED = "NotSpecified"
    CAN_NOT_DELETE = "CanNotDelete"
    READ_ONLY = "ReadOnly"


class NotificationDeliveryMechanism(str, Enum):
    """
    The type of notification.
    """
    EMAIL = "Email"


class NotificationLevel(str, Enum):
    """
    The notification level.
    """
    NONE = "None"
    CRITICAL = "Critical"
    ALL = "All"


class OverrideKind(str, Enum):
    """
    The override kind.
    """
    POLICY_EFFECT = "policyEffect"
    """
    It will override the policy effect type.
    """
    DEFINITION_VERSION = "definitionVersion"
    """
    It will override the definition version property value of the policy assignment.
    """


class PIMOnlyMode(str, Enum):
    """
    Determines whether the setting is enabled, disabled or report only.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"
    REPORT_ONLY = "ReportOnly"


class ParameterType(str, Enum):
    """
    The data type of the parameter.
    """
    STRING = "String"
    ARRAY = "Array"
    OBJECT = "Object"
    BOOLEAN = "Boolean"
    INTEGER = "Integer"
    FLOAT = "Float"
    DATE_TIME = "DateTime"


class PolicyType(str, Enum):
    """
    The type of policy definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
    """
    NOT_SPECIFIED = "NotSpecified"
    BUILT_IN = "BuiltIn"
    CUSTOM = "Custom"
    STATIC = "Static"


class PrincipalType(str, Enum):
    """
    The principal type of the assigned principal ID.
    """
    USER = "User"
    GROUP = "Group"
    SERVICE_PRINCIPAL = "ServicePrincipal"
    FOREIGN_GROUP = "ForeignGroup"
    DEVICE = "Device"


class PublicNetworkAccessOptions(str, Enum):
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class RecipientType(str, Enum):
    """
    The recipient type.
    """
    REQUESTOR = "Requestor"
    APPROVER = "Approver"
    ADMIN = "Admin"


class RequestType(str, Enum):
    """
    The type of the role assignment schedule request. Eg: SelfActivate, AdminAssign etc
    """
    ADMIN_ASSIGN = "AdminAssign"
    ADMIN_REMOVE = "AdminRemove"
    ADMIN_UPDATE = "AdminUpdate"
    ADMIN_EXTEND = "AdminExtend"
    ADMIN_RENEW = "AdminRenew"
    SELF_ACTIVATE = "SelfActivate"
    SELF_DEACTIVATE = "SelfDeactivate"
    SELF_EXTEND = "SelfExtend"
    SELF_RENEW = "SelfRenew"


class ResourceIdentityType(str, Enum):
    """
    The identity type. This is the only required field when adding a system or user assigned identity to a resource.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    """
    Indicates that a system assigned identity is associated with the resource.
    """
    USER_ASSIGNED = "UserAssigned"
    """
    Indicates that a system assigned identity is associated with the resource.
    """
    NONE = "None"
    """
    Indicates that no identity is associated with the resource or that the existing identity should be removed.
    """


class RoleManagementPolicyRuleType(str, Enum):
    """
    The type of rule
    """
    ROLE_MANAGEMENT_POLICY_APPROVAL_RULE = "RoleManagementPolicyApprovalRule"
    ROLE_MANAGEMENT_POLICY_AUTHENTICATION_CONTEXT_RULE = "RoleManagementPolicyAuthenticationContextRule"
    ROLE_MANAGEMENT_POLICY_ENABLEMENT_RULE = "RoleManagementPolicyEnablementRule"
    ROLE_MANAGEMENT_POLICY_EXPIRATION_RULE = "RoleManagementPolicyExpirationRule"
    ROLE_MANAGEMENT_POLICY_NOTIFICATION_RULE = "RoleManagementPolicyNotificationRule"
    ROLE_MANAGEMENT_POLICY_PIM_ONLY_MODE_RULE = "RoleManagementPolicyPimOnlyModeRule"


class SelectorKind(str, Enum):
    """
    The selector kind.
    """
    RESOURCE_LOCATION = "resourceLocation"
    """
    The selector kind to filter policies by the resource location.
    """
    RESOURCE_TYPE = "resourceType"
    """
    The selector kind to filter policies by the resource type.
    """
    RESOURCE_WITHOUT_LOCATION = "resourceWithoutLocation"
    """
    The selector kind to filter policies by the resource without location.
    """
    POLICY_DEFINITION_REFERENCE_ID = "policyDefinitionReferenceId"
    """
    The selector kind to filter policies by the policy definition reference ID.
    """


class Type(str, Enum):
    """
    Type of the role eligibility schedule expiration
    """
    AFTER_DURATION = "AfterDuration"
    AFTER_DATE_TIME = "AfterDateTime"
    NO_EXPIRATION = "NoExpiration"


class UserType(str, Enum):
    """
    The type of user.
    """
    USER = "User"
    GROUP = "Group"
    SERVICE_PRINCIPAL = "ServicePrincipal"
