# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetVariableAtManagementGroupResult',
    'AwaitableGetVariableAtManagementGroupResult',
    'get_variable_at_management_group',
    'get_variable_at_management_group_output',
]

@pulumi.output_type
class GetVariableAtManagementGroupResult:
    """
    The variable.
    """
    def __init__(__self__, azure_api_version=None, columns=None, id=None, name=None, system_data=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if columns and not isinstance(columns, list):
            raise TypeError("Expected argument 'columns' to be a list")
        pulumi.set(__self__, "columns", columns)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def columns(self) -> Sequence['outputs.PolicyVariableColumnResponse']:
        """
        Variable column definitions.
        """
        return pulumi.get(self, "columns")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the variable.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the variable.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource (Microsoft.Authorization/variables).
        """
        return pulumi.get(self, "type")


class AwaitableGetVariableAtManagementGroupResult(GetVariableAtManagementGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVariableAtManagementGroupResult(
            azure_api_version=self.azure_api_version,
            columns=self.columns,
            id=self.id,
            name=self.name,
            system_data=self.system_data,
            type=self.type)


def get_variable_at_management_group(management_group_id: Optional[str] = None,
                                     variable_name: Optional[str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVariableAtManagementGroupResult:
    """
    This operation retrieves a single variable, given its name and the  management group it was created at.

    Uses Azure REST API version 2022-08-01-preview.

    Other available API versions: 2024-12-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str management_group_id: The ID of the management group.
    :param str variable_name: The name of the variable to operate on.
    """
    __args__ = dict()
    __args__['managementGroupId'] = management_group_id
    __args__['variableName'] = variable_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:authorization:getVariableAtManagementGroup', __args__, opts=opts, typ=GetVariableAtManagementGroupResult).value

    return AwaitableGetVariableAtManagementGroupResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        columns=pulumi.get(__ret__, 'columns'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_variable_at_management_group_output(management_group_id: Optional[pulumi.Input[str]] = None,
                                            variable_name: Optional[pulumi.Input[str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVariableAtManagementGroupResult]:
    """
    This operation retrieves a single variable, given its name and the  management group it was created at.

    Uses Azure REST API version 2022-08-01-preview.

    Other available API versions: 2024-12-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str management_group_id: The ID of the management group.
    :param str variable_name: The name of the variable to operate on.
    """
    __args__ = dict()
    __args__['managementGroupId'] = management_group_id
    __args__['variableName'] = variable_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:authorization:getVariableAtManagementGroup', __args__, opts=opts, typ=GetVariableAtManagementGroupResult)
    return __ret__.apply(lambda __response__: GetVariableAtManagementGroupResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        columns=pulumi.get(__response__, 'columns'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
