# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListPolicySetDefinitionVersionAllAtManagementGroupResult',
    'AwaitableListPolicySetDefinitionVersionAllAtManagementGroupResult',
    'list_policy_set_definition_version_all_at_management_group',
    'list_policy_set_definition_version_all_at_management_group_output',
]

@pulumi.output_type
class ListPolicySetDefinitionVersionAllAtManagementGroupResult:
    """
    List of policy set definition versions.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        The URL to use for getting the next set of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.PolicySetDefinitionVersionResponse']]:
        """
        An array of policy set definition versions.
        """
        return pulumi.get(self, "value")


class AwaitableListPolicySetDefinitionVersionAllAtManagementGroupResult(ListPolicySetDefinitionVersionAllAtManagementGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListPolicySetDefinitionVersionAllAtManagementGroupResult(
            next_link=self.next_link,
            value=self.value)


def list_policy_set_definition_version_all_at_management_group(management_group_name: Optional[str] = None,
                                                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListPolicySetDefinitionVersionAllAtManagementGroupResult:
    """
    This operation lists all the policy set definition versions for all policy set definitions at the management group scope.

    Uses Azure REST API version 2025-01-01.

    Other available API versions: 2023-04-01, 2024-05-01, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str management_group_name: The name of the management group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['managementGroupName'] = management_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:authorization:listPolicySetDefinitionVersionAllAtManagementGroup', __args__, opts=opts, typ=ListPolicySetDefinitionVersionAllAtManagementGroupResult).value

    return AwaitableListPolicySetDefinitionVersionAllAtManagementGroupResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_policy_set_definition_version_all_at_management_group_output(management_group_name: Optional[pulumi.Input[str]] = None,
                                                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListPolicySetDefinitionVersionAllAtManagementGroupResult]:
    """
    This operation lists all the policy set definition versions for all policy set definitions at the management group scope.

    Uses Azure REST API version 2025-01-01.

    Other available API versions: 2023-04-01, 2024-05-01, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str management_group_name: The name of the management group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['managementGroupName'] = management_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:authorization:listPolicySetDefinitionVersionAllAtManagementGroup', __args__, opts=opts, typ=ListPolicySetDefinitionVersionAllAtManagementGroupResult)
    return __ret__.apply(lambda __response__: ListPolicySetDefinitionVersionAllAtManagementGroupResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
