# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetFlowSourceAddressesResult',
    'AwaitableGetFlowSourceAddressesResult',
    'get_flow_source_addresses',
    'get_flow_source_addresses_output',
]

@pulumi.output_type
class GetFlowSourceAddressesResult:
    """
    The source IP address and CIDR ranges of the stream
    """
    def __init__(__self__, source_addresses=None):
        if source_addresses and not isinstance(source_addresses, list):
            raise TypeError("Expected argument 'source_addresses' to be a list")
        pulumi.set(__self__, "source_addresses", source_addresses)

    @property
    @pulumi.getter(name="sourceAddresses")
    def source_addresses(self) -> Optional[Sequence[str]]:
        """
        A source IP address or CIDR range
        """
        return pulumi.get(self, "source_addresses")


class AwaitableGetFlowSourceAddressesResult(GetFlowSourceAddressesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFlowSourceAddressesResult(
            source_addresses=self.source_addresses)


def get_flow_source_addresses(connection_name: Optional[str] = None,
                              flow_name: Optional[str] = None,
                              resource_group_name: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFlowSourceAddressesResult:
    """
    Get the source addresses for the specified flow.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str connection_name: The name for the connection that is to be requested.
    :param str flow_name: The name for the flow that is to be onboarded.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['flowName'] = flow_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azuredatatransfer:getFlowSourceAddresses', __args__, opts=opts, typ=GetFlowSourceAddressesResult).value

    return AwaitableGetFlowSourceAddressesResult(
        source_addresses=pulumi.get(__ret__, 'source_addresses'))
def get_flow_source_addresses_output(connection_name: Optional[pulumi.Input[str]] = None,
                                     flow_name: Optional[pulumi.Input[str]] = None,
                                     resource_group_name: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFlowSourceAddressesResult]:
    """
    Get the source addresses for the specified flow.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str connection_name: The name for the connection that is to be requested.
    :param str flow_name: The name for the flow that is to be onboarded.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['flowName'] = flow_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:azuredatatransfer:getFlowSourceAddresses', __args__, opts=opts, typ=GetFlowSourceAddressesResult)
    return __ret__.apply(lambda __response__: GetFlowSourceAddressesResult(
        source_addresses=pulumi.get(__response__, 'source_addresses')))
