# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['AzureLargeInstanceArgs', 'AzureLargeInstance']

@pulumi.input_type
class AzureLargeInstanceArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[str],
                 azure_large_instance_id: Optional[pulumi.Input[str]] = None,
                 azure_large_instance_name: Optional[pulumi.Input[str]] = None,
                 hardware_profile: Optional[pulumi.Input['HardwareProfileArgs']] = None,
                 hw_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 network_profile: Optional[pulumi.Input['NetworkProfileArgs']] = None,
                 os_profile: Optional[pulumi.Input['OsProfileArgs']] = None,
                 power_state: Optional[pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']]] = None,
                 proximity_placement_group: Optional[pulumi.Input[str]] = None,
                 storage_profile: Optional[pulumi.Input['StorageProfileArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a AzureLargeInstance resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] azure_large_instance_id: Specifies the Azure Large Instance unique ID.
        :param pulumi.Input[str] azure_large_instance_name: Name of the AzureLargeInstance.
        :param pulumi.Input['HardwareProfileArgs'] hardware_profile: Specifies the hardware settings for the Azure Large Instance.
        :param pulumi.Input[str] hw_revision: Hardware revision of an Azure Large Instance
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input['NetworkProfileArgs'] network_profile: Specifies the network settings for the Azure Large Instance.
        :param pulumi.Input['OsProfileArgs'] os_profile: Specifies the operating system settings for the Azure Large Instance.
        :param pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']] power_state: Resource power state
        :param pulumi.Input[str] proximity_placement_group: Resource proximity placement group
        :param pulumi.Input['StorageProfileArgs'] storage_profile: Specifies the storage settings for the Azure Large Instance disks.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if azure_large_instance_id is not None:
            pulumi.set(__self__, "azure_large_instance_id", azure_large_instance_id)
        if azure_large_instance_name is not None:
            pulumi.set(__self__, "azure_large_instance_name", azure_large_instance_name)
        if hardware_profile is not None:
            pulumi.set(__self__, "hardware_profile", hardware_profile)
        if hw_revision is not None:
            pulumi.set(__self__, "hw_revision", hw_revision)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if network_profile is not None:
            pulumi.set(__self__, "network_profile", network_profile)
        if os_profile is not None:
            pulumi.set(__self__, "os_profile", os_profile)
        if power_state is not None:
            pulumi.set(__self__, "power_state", power_state)
        if proximity_placement_group is not None:
            pulumi.set(__self__, "proximity_placement_group", proximity_placement_group)
        if storage_profile is not None:
            pulumi.set(__self__, "storage_profile", storage_profile)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="azureLargeInstanceId")
    def azure_large_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the Azure Large Instance unique ID.
        """
        return pulumi.get(self, "azure_large_instance_id")

    @azure_large_instance_id.setter
    def azure_large_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "azure_large_instance_id", value)

    @property
    @pulumi.getter(name="azureLargeInstanceName")
    def azure_large_instance_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the AzureLargeInstance.
        """
        return pulumi.get(self, "azure_large_instance_name")

    @azure_large_instance_name.setter
    def azure_large_instance_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "azure_large_instance_name", value)

    @property
    @pulumi.getter(name="hardwareProfile")
    def hardware_profile(self) -> Optional[pulumi.Input['HardwareProfileArgs']]:
        """
        Specifies the hardware settings for the Azure Large Instance.
        """
        return pulumi.get(self, "hardware_profile")

    @hardware_profile.setter
    def hardware_profile(self, value: Optional[pulumi.Input['HardwareProfileArgs']]):
        pulumi.set(self, "hardware_profile", value)

    @property
    @pulumi.getter(name="hwRevision")
    def hw_revision(self) -> Optional[pulumi.Input[str]]:
        """
        Hardware revision of an Azure Large Instance
        """
        return pulumi.get(self, "hw_revision")

    @hw_revision.setter
    def hw_revision(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hw_revision", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="networkProfile")
    def network_profile(self) -> Optional[pulumi.Input['NetworkProfileArgs']]:
        """
        Specifies the network settings for the Azure Large Instance.
        """
        return pulumi.get(self, "network_profile")

    @network_profile.setter
    def network_profile(self, value: Optional[pulumi.Input['NetworkProfileArgs']]):
        pulumi.set(self, "network_profile", value)

    @property
    @pulumi.getter(name="osProfile")
    def os_profile(self) -> Optional[pulumi.Input['OsProfileArgs']]:
        """
        Specifies the operating system settings for the Azure Large Instance.
        """
        return pulumi.get(self, "os_profile")

    @os_profile.setter
    def os_profile(self, value: Optional[pulumi.Input['OsProfileArgs']]):
        pulumi.set(self, "os_profile", value)

    @property
    @pulumi.getter(name="powerState")
    def power_state(self) -> Optional[pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']]]:
        """
        Resource power state
        """
        return pulumi.get(self, "power_state")

    @power_state.setter
    def power_state(self, value: Optional[pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']]]):
        pulumi.set(self, "power_state", value)

    @property
    @pulumi.getter(name="proximityPlacementGroup")
    def proximity_placement_group(self) -> Optional[pulumi.Input[str]]:
        """
        Resource proximity placement group
        """
        return pulumi.get(self, "proximity_placement_group")

    @proximity_placement_group.setter
    def proximity_placement_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "proximity_placement_group", value)

    @property
    @pulumi.getter(name="storageProfile")
    def storage_profile(self) -> Optional[pulumi.Input['StorageProfileArgs']]:
        """
        Specifies the storage settings for the Azure Large Instance disks.
        """
        return pulumi.get(self, "storage_profile")

    @storage_profile.setter
    def storage_profile(self, value: Optional[pulumi.Input['StorageProfileArgs']]):
        pulumi.set(self, "storage_profile", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class AzureLargeInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 azure_large_instance_id: Optional[pulumi.Input[str]] = None,
                 azure_large_instance_name: Optional[pulumi.Input[str]] = None,
                 hardware_profile: Optional[pulumi.Input[Union['HardwareProfileArgs', 'HardwareProfileArgsDict']]] = None,
                 hw_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 network_profile: Optional[pulumi.Input[Union['NetworkProfileArgs', 'NetworkProfileArgsDict']]] = None,
                 os_profile: Optional[pulumi.Input[Union['OsProfileArgs', 'OsProfileArgsDict']]] = None,
                 power_state: Optional[pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']]] = None,
                 proximity_placement_group: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 storage_profile: Optional[pulumi.Input[Union['StorageProfileArgs', 'StorageProfileArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Azure Large Instance info on Azure (ARM properties and AzureLargeInstance
        properties)

        Uses Azure REST API version 2024-08-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-08-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] azure_large_instance_id: Specifies the Azure Large Instance unique ID.
        :param pulumi.Input[str] azure_large_instance_name: Name of the AzureLargeInstance.
        :param pulumi.Input[Union['HardwareProfileArgs', 'HardwareProfileArgsDict']] hardware_profile: Specifies the hardware settings for the Azure Large Instance.
        :param pulumi.Input[str] hw_revision: Hardware revision of an Azure Large Instance
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[Union['NetworkProfileArgs', 'NetworkProfileArgsDict']] network_profile: Specifies the network settings for the Azure Large Instance.
        :param pulumi.Input[Union['OsProfileArgs', 'OsProfileArgsDict']] os_profile: Specifies the operating system settings for the Azure Large Instance.
        :param pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']] power_state: Resource power state
        :param pulumi.Input[str] proximity_placement_group: Resource proximity placement group
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union['StorageProfileArgs', 'StorageProfileArgsDict']] storage_profile: Specifies the storage settings for the Azure Large Instance disks.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AzureLargeInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Azure Large Instance info on Azure (ARM properties and AzureLargeInstance
        properties)

        Uses Azure REST API version 2024-08-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-08-01-preview.

        :param str resource_name: The name of the resource.
        :param AzureLargeInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AzureLargeInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 azure_large_instance_id: Optional[pulumi.Input[str]] = None,
                 azure_large_instance_name: Optional[pulumi.Input[str]] = None,
                 hardware_profile: Optional[pulumi.Input[Union['HardwareProfileArgs', 'HardwareProfileArgsDict']]] = None,
                 hw_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 network_profile: Optional[pulumi.Input[Union['NetworkProfileArgs', 'NetworkProfileArgsDict']]] = None,
                 os_profile: Optional[pulumi.Input[Union['OsProfileArgs', 'OsProfileArgsDict']]] = None,
                 power_state: Optional[pulumi.Input[Union[str, 'AzureLargeInstancePowerStateEnum']]] = None,
                 proximity_placement_group: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 storage_profile: Optional[pulumi.Input[Union['StorageProfileArgs', 'StorageProfileArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AzureLargeInstanceArgs.__new__(AzureLargeInstanceArgs)

            __props__.__dict__["azure_large_instance_id"] = azure_large_instance_id
            __props__.__dict__["azure_large_instance_name"] = azure_large_instance_name
            __props__.__dict__["hardware_profile"] = hardware_profile
            __props__.__dict__["hw_revision"] = hw_revision
            __props__.__dict__["location"] = location
            __props__.__dict__["network_profile"] = network_profile
            __props__.__dict__["os_profile"] = os_profile
            __props__.__dict__["power_state"] = power_state
            __props__.__dict__["proximity_placement_group"] = proximity_placement_group
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["storage_profile"] = storage_profile
            __props__.__dict__["tags"] = tags
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:azurelargeinstance/v20240801preview:AzureLargeInstance")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(AzureLargeInstance, __self__).__init__(
            'azure-native:azurelargeinstance:AzureLargeInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'AzureLargeInstance':
        """
        Get an existing AzureLargeInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = AzureLargeInstanceArgs.__new__(AzureLargeInstanceArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["azure_large_instance_id"] = None
        __props__.__dict__["hardware_profile"] = None
        __props__.__dict__["hw_revision"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["network_profile"] = None
        __props__.__dict__["os_profile"] = None
        __props__.__dict__["power_state"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["proximity_placement_group"] = None
        __props__.__dict__["storage_profile"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return AzureLargeInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="azureLargeInstanceId")
    def azure_large_instance_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the Azure Large Instance unique ID.
        """
        return pulumi.get(self, "azure_large_instance_id")

    @property
    @pulumi.getter(name="hardwareProfile")
    def hardware_profile(self) -> pulumi.Output[Optional['outputs.HardwareProfileResponse']]:
        """
        Specifies the hardware settings for the Azure Large Instance.
        """
        return pulumi.get(self, "hardware_profile")

    @property
    @pulumi.getter(name="hwRevision")
    def hw_revision(self) -> pulumi.Output[Optional[str]]:
        """
        Hardware revision of an Azure Large Instance
        """
        return pulumi.get(self, "hw_revision")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkProfile")
    def network_profile(self) -> pulumi.Output[Optional['outputs.NetworkProfileResponse']]:
        """
        Specifies the network settings for the Azure Large Instance.
        """
        return pulumi.get(self, "network_profile")

    @property
    @pulumi.getter(name="osProfile")
    def os_profile(self) -> pulumi.Output[Optional['outputs.OsProfileResponse']]:
        """
        Specifies the operating system settings for the Azure Large Instance.
        """
        return pulumi.get(self, "os_profile")

    @property
    @pulumi.getter(name="powerState")
    def power_state(self) -> pulumi.Output[Optional[str]]:
        """
        Resource power state
        """
        return pulumi.get(self, "power_state")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        State of provisioning of the AzureLargeInstance
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="proximityPlacementGroup")
    def proximity_placement_group(self) -> pulumi.Output[Optional[str]]:
        """
        Resource proximity placement group
        """
        return pulumi.get(self, "proximity_placement_group")

    @property
    @pulumi.getter(name="storageProfile")
    def storage_profile(self) -> pulumi.Output[Optional['outputs.StorageProfileResponse']]:
        """
        Specifies the storage settings for the Azure Large Instance disks.
        """
        return pulumi.get(self, "storage_profile")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

