# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetAFDTargetGroupResult',
    'AwaitableGetAFDTargetGroupResult',
    'get_afd_target_group',
    'get_afd_target_group_output',
]

@pulumi.output_type
class GetAFDTargetGroupResult:
    """
    AFDTargetGroup comprises a list of Endpoints that is used for tunnelling protocols to allow certain traffic.
    """
    def __init__(__self__, azure_api_version=None, deployment_status=None, id=None, name=None, provisioning_state=None, system_data=None, target_endpoints=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if deployment_status and not isinstance(deployment_status, str):
            raise TypeError("Expected argument 'deployment_status' to be a str")
        pulumi.set(__self__, "deployment_status", deployment_status)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if target_endpoints and not isinstance(target_endpoints, list):
            raise TypeError("Expected argument 'target_endpoints' to be a list")
        pulumi.set(__self__, "target_endpoints", target_endpoints)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="deploymentStatus")
    def deployment_status(self) -> str:
        return pulumi.get(self, "deployment_status")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        Provisioning status
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Read only system data
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="targetEndpoints")
    def target_endpoints(self) -> Sequence['outputs.TargetEndpointResponse']:
        """
        TargetEndpoint list referenced by this target group.
        """
        return pulumi.get(self, "target_endpoints")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetAFDTargetGroupResult(GetAFDTargetGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAFDTargetGroupResult(
            azure_api_version=self.azure_api_version,
            deployment_status=self.deployment_status,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            target_endpoints=self.target_endpoints,
            type=self.type)


def get_afd_target_group(profile_name: Optional[str] = None,
                         resource_group_name: Optional[str] = None,
                         target_group_name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAFDTargetGroupResult:
    """
    Gets an existing target group within a profile.

    Uses Azure REST API version 2024-06-01-preview.


    :param str profile_name: Name of the Azure Front Door Standard or Azure Front Door Premium which is unique within the resource group.
    :param str resource_group_name: Name of the Resource group within the Azure subscription.
    :param str target_group_name: Name of the Target Group under the profile.
    """
    __args__ = dict()
    __args__['profileName'] = profile_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['targetGroupName'] = target_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:cdn:getAFDTargetGroup', __args__, opts=opts, typ=GetAFDTargetGroupResult).value

    return AwaitableGetAFDTargetGroupResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        deployment_status=pulumi.get(__ret__, 'deployment_status'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        target_endpoints=pulumi.get(__ret__, 'target_endpoints'),
        type=pulumi.get(__ret__, 'type'))
def get_afd_target_group_output(profile_name: Optional[pulumi.Input[str]] = None,
                                resource_group_name: Optional[pulumi.Input[str]] = None,
                                target_group_name: Optional[pulumi.Input[str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAFDTargetGroupResult]:
    """
    Gets an existing target group within a profile.

    Uses Azure REST API version 2024-06-01-preview.


    :param str profile_name: Name of the Azure Front Door Standard or Azure Front Door Premium which is unique within the resource group.
    :param str resource_group_name: Name of the Resource group within the Azure subscription.
    :param str target_group_name: Name of the Target Group under the profile.
    """
    __args__ = dict()
    __args__['profileName'] = profile_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['targetGroupName'] = target_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:cdn:getAFDTargetGroup', __args__, opts=opts, typ=GetAFDTargetGroupResult)
    return __ret__.apply(lambda __response__: GetAFDTargetGroupResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        deployment_status=pulumi.get(__response__, 'deployment_status'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        system_data=pulumi.get(__response__, 'system_data'),
        target_endpoints=pulumi.get(__response__, 'target_endpoints'),
        type=pulumi.get(__response__, 'type')))
