# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrganizationEnvironmentByIdResult',
    'AwaitableGetOrganizationEnvironmentByIdResult',
    'get_organization_environment_by_id',
    'get_organization_environment_by_id_output',
]

@pulumi.output_type
class GetOrganizationEnvironmentByIdResult:
    """
    Details about environment name, metadata and environment id of an environment
    """
    def __init__(__self__, azure_api_version=None, id=None, kind=None, metadata=None, name=None, stream_governance_config=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kind and not isinstance(kind, str):
            raise TypeError("Expected argument 'kind' to be a str")
        pulumi.set(__self__, "kind", kind)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if stream_governance_config and not isinstance(stream_governance_config, dict):
            raise TypeError("Expected argument 'stream_governance_config' to be a dict")
        pulumi.set(__self__, "stream_governance_config", stream_governance_config)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Id of the environment
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def kind(self) -> Optional[str]:
        """
        Type of environment
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def metadata(self) -> Optional['outputs.SCMetadataEntityResponse']:
        """
        Metadata of the record
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Display name of the environment
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="streamGovernanceConfig")
    def stream_governance_config(self) -> Optional['outputs.StreamGovernanceConfigResponse']:
        """
        Stream governance configuration
        """
        return pulumi.get(self, "stream_governance_config")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Type of the resource
        """
        return pulumi.get(self, "type")


class AwaitableGetOrganizationEnvironmentByIdResult(GetOrganizationEnvironmentByIdResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationEnvironmentByIdResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            kind=self.kind,
            metadata=self.metadata,
            name=self.name,
            stream_governance_config=self.stream_governance_config,
            type=self.type)


def get_organization_environment_by_id(environment_id: Optional[str] = None,
                                       organization_name: Optional[str] = None,
                                       resource_group_name: Optional[str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationEnvironmentByIdResult:
    """
    Details about environment name, metadata and environment id of an environment

    Uses Azure REST API version 2024-07-01.


    :param str environment_id: Confluent environment id
    :param str organization_name: Organization resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['environmentId'] = environment_id
    __args__['organizationName'] = organization_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:confluent:getOrganizationEnvironmentById', __args__, opts=opts, typ=GetOrganizationEnvironmentByIdResult).value

    return AwaitableGetOrganizationEnvironmentByIdResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        kind=pulumi.get(__ret__, 'kind'),
        metadata=pulumi.get(__ret__, 'metadata'),
        name=pulumi.get(__ret__, 'name'),
        stream_governance_config=pulumi.get(__ret__, 'stream_governance_config'),
        type=pulumi.get(__ret__, 'type'))
def get_organization_environment_by_id_output(environment_id: Optional[pulumi.Input[str]] = None,
                                              organization_name: Optional[pulumi.Input[str]] = None,
                                              resource_group_name: Optional[pulumi.Input[str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOrganizationEnvironmentByIdResult]:
    """
    Details about environment name, metadata and environment id of an environment

    Uses Azure REST API version 2024-07-01.


    :param str environment_id: Confluent environment id
    :param str organization_name: Organization resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['environmentId'] = environment_id
    __args__['organizationName'] = organization_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:confluent:getOrganizationEnvironmentById', __args__, opts=opts, typ=GetOrganizationEnvironmentByIdResult)
    return __ret__.apply(lambda __response__: GetOrganizationEnvironmentByIdResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        kind=pulumi.get(__response__, 'kind'),
        metadata=pulumi.get(__response__, 'metadata'),
        name=pulumi.get(__response__, 'name'),
        stream_governance_config=pulumi.get(__response__, 'stream_governance_config'),
        type=pulumi.get(__response__, 'type')))
