# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListAccessEnvironmentsResult',
    'AwaitableListAccessEnvironmentsResult',
    'list_access_environments',
    'list_access_environments_output',
]

@pulumi.output_type
class ListAccessEnvironmentsResult:
    """
    Details of the environments returned on successful response
    """
    def __init__(__self__, data=None, kind=None, metadata=None):
        if data and not isinstance(data, list):
            raise TypeError("Expected argument 'data' to be a list")
        pulumi.set(__self__, "data", data)
        if kind and not isinstance(kind, str):
            raise TypeError("Expected argument 'kind' to be a str")
        pulumi.set(__self__, "kind", kind)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter
    def data(self) -> Optional[Sequence['outputs.EnvironmentRecordResponse']]:
        """
        Environment list data
        """
        return pulumi.get(self, "data")

    @property
    @pulumi.getter
    def kind(self) -> Optional[str]:
        """
        Type of response
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def metadata(self) -> Optional['outputs.ConfluentListMetadataResponse']:
        """
        Metadata of the  environment list
        """
        return pulumi.get(self, "metadata")


class AwaitableListAccessEnvironmentsResult(ListAccessEnvironmentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAccessEnvironmentsResult(
            data=self.data,
            kind=self.kind,
            metadata=self.metadata)


def list_access_environments(organization_name: Optional[str] = None,
                             resource_group_name: Optional[str] = None,
                             search_filters: Optional[Mapping[str, str]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAccessEnvironmentsResult:
    """
    Details of the environments returned on successful response

    Uses Azure REST API version 2024-07-01.

    Other available API versions: 2023-08-22, 2024-02-13. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native confluent [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str organization_name: Organization resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param Mapping[str, str] search_filters: Search filters for the request
    """
    __args__ = dict()
    __args__['organizationName'] = organization_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['searchFilters'] = search_filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:confluent:listAccessEnvironments', __args__, opts=opts, typ=ListAccessEnvironmentsResult).value

    return AwaitableListAccessEnvironmentsResult(
        data=pulumi.get(__ret__, 'data'),
        kind=pulumi.get(__ret__, 'kind'),
        metadata=pulumi.get(__ret__, 'metadata'))
def list_access_environments_output(organization_name: Optional[pulumi.Input[str]] = None,
                                    resource_group_name: Optional[pulumi.Input[str]] = None,
                                    search_filters: Optional[pulumi.Input[Optional[Mapping[str, str]]]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAccessEnvironmentsResult]:
    """
    Details of the environments returned on successful response

    Uses Azure REST API version 2024-07-01.

    Other available API versions: 2023-08-22, 2024-02-13. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native confluent [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str organization_name: Organization resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param Mapping[str, str] search_filters: Search filters for the request
    """
    __args__ = dict()
    __args__['organizationName'] = organization_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['searchFilters'] = search_filters
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:confluent:listAccessEnvironments', __args__, opts=opts, typ=ListAccessEnvironmentsResult)
    return __ret__.apply(lambda __response__: ListAccessEnvironmentsResult(
        data=pulumi.get(__response__, 'data'),
        kind=pulumi.get(__response__, 'kind'),
        metadata=pulumi.get(__response__, 'metadata')))
