# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListOrderDCAccessCodeResult',
    'AwaitableListOrderDCAccessCodeResult',
    'list_order_dc_access_code',
    'list_order_dc_access_code_output',
]

@pulumi.output_type
class ListOrderDCAccessCodeResult:
    """
    DC Access code in the case of Self Managed Shipping.
    """
    def __init__(__self__, auth_code=None):
        if auth_code and not isinstance(auth_code, str):
            raise TypeError("Expected argument 'auth_code' to be a str")
        pulumi.set(__self__, "auth_code", auth_code)

    @property
    @pulumi.getter(name="authCode")
    def auth_code(self) -> Optional[str]:
        """
        DCAccess Code for the Self Managed shipment.
        """
        return pulumi.get(self, "auth_code")


class AwaitableListOrderDCAccessCodeResult(ListOrderDCAccessCodeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListOrderDCAccessCodeResult(
            auth_code=self.auth_code)


def list_order_dc_access_code(device_name: Optional[str] = None,
                              resource_group_name: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListOrderDCAccessCodeResult:
    """
    DC Access code in the case of Self Managed Shipping.

    Uses Azure REST API version 2023-07-01.

    Other available API versions: 2022-03-01, 2022-04-01-preview, 2022-12-01-preview, 2023-01-01-preview, 2023-12-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native databoxedge [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str device_name: The device name
    :param str resource_group_name: The resource group name.
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:databoxedge:listOrderDCAccessCode', __args__, opts=opts, typ=ListOrderDCAccessCodeResult).value

    return AwaitableListOrderDCAccessCodeResult(
        auth_code=pulumi.get(__ret__, 'auth_code'))
def list_order_dc_access_code_output(device_name: Optional[pulumi.Input[str]] = None,
                                     resource_group_name: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListOrderDCAccessCodeResult]:
    """
    DC Access code in the case of Self Managed Shipping.

    Uses Azure REST API version 2023-07-01.

    Other available API versions: 2022-03-01, 2022-04-01-preview, 2022-12-01-preview, 2023-01-01-preview, 2023-12-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native databoxedge [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str device_name: The device name
    :param str resource_group_name: The resource group name.
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:databoxedge:listOrderDCAccessCode', __args__, opts=opts, typ=ListOrderDCAccessCodeResult)
    return __ret__.apply(lambda __response__: ListOrderDCAccessCodeResult(
        auth_code=pulumi.get(__response__, 'auth_code')))
