# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetProjectCatalogSyncErrorDetailsResult',
    'AwaitableGetProjectCatalogSyncErrorDetailsResult',
    'get_project_catalog_sync_error_details',
    'get_project_catalog_sync_error_details_output',
]

@pulumi.output_type
class GetProjectCatalogSyncErrorDetailsResult:
    """
    Synchronization error details.
    """
    def __init__(__self__, conflicts=None, errors=None, operation_error=None):
        if conflicts and not isinstance(conflicts, list):
            raise TypeError("Expected argument 'conflicts' to be a list")
        pulumi.set(__self__, "conflicts", conflicts)
        if errors and not isinstance(errors, list):
            raise TypeError("Expected argument 'errors' to be a list")
        pulumi.set(__self__, "errors", errors)
        if operation_error and not isinstance(operation_error, dict):
            raise TypeError("Expected argument 'operation_error' to be a dict")
        pulumi.set(__self__, "operation_error", operation_error)

    @property
    @pulumi.getter
    def conflicts(self) -> Sequence['outputs.CatalogConflictErrorResponse']:
        """
        Catalog items that have conflicting names.
        """
        return pulumi.get(self, "conflicts")

    @property
    @pulumi.getter
    def errors(self) -> Sequence['outputs.CatalogSyncErrorResponse']:
        """
        Errors that occured during synchronization.
        """
        return pulumi.get(self, "errors")

    @property
    @pulumi.getter(name="operationError")
    def operation_error(self) -> 'outputs.CatalogErrorDetailsResponse':
        """
        Error information for the overall synchronization operation.
        """
        return pulumi.get(self, "operation_error")


class AwaitableGetProjectCatalogSyncErrorDetailsResult(GetProjectCatalogSyncErrorDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProjectCatalogSyncErrorDetailsResult(
            conflicts=self.conflicts,
            errors=self.errors,
            operation_error=self.operation_error)


def get_project_catalog_sync_error_details(catalog_name: Optional[str] = None,
                                           project_name: Optional[str] = None,
                                           resource_group_name: Optional[str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProjectCatalogSyncErrorDetailsResult:
    """
    Gets project catalog synchronization error details

    Uses Azure REST API version 2024-02-01.

    Other available API versions: 2024-05-01-preview, 2024-06-01-preview, 2024-07-01-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-02-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str catalog_name: The name of the Catalog.
    :param str project_name: The name of the project.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['catalogName'] = catalog_name
    __args__['projectName'] = project_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devcenter:getProjectCatalogSyncErrorDetails', __args__, opts=opts, typ=GetProjectCatalogSyncErrorDetailsResult).value

    return AwaitableGetProjectCatalogSyncErrorDetailsResult(
        conflicts=pulumi.get(__ret__, 'conflicts'),
        errors=pulumi.get(__ret__, 'errors'),
        operation_error=pulumi.get(__ret__, 'operation_error'))
def get_project_catalog_sync_error_details_output(catalog_name: Optional[pulumi.Input[str]] = None,
                                                  project_name: Optional[pulumi.Input[str]] = None,
                                                  resource_group_name: Optional[pulumi.Input[str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetProjectCatalogSyncErrorDetailsResult]:
    """
    Gets project catalog synchronization error details

    Uses Azure REST API version 2024-02-01.

    Other available API versions: 2024-05-01-preview, 2024-06-01-preview, 2024-07-01-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-02-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str catalog_name: The name of the Catalog.
    :param str project_name: The name of the project.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['catalogName'] = catalog_name
    __args__['projectName'] = project_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:devcenter:getProjectCatalogSyncErrorDetails', __args__, opts=opts, typ=GetProjectCatalogSyncErrorDetailsResult)
    return __ret__.apply(lambda __response__: GetProjectCatalogSyncErrorDetailsResult(
        conflicts=pulumi.get(__response__, 'conflicts'),
        errors=pulumi.get(__response__, 'errors'),
        operation_error=pulumi.get(__response__, 'operation_error')))
