# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['DiscoveredAssetArgs', 'DiscoveredAsset']

@pulumi.input_type
class DiscoveredAssetArgs:
    def __init__(__self__, *,
                 asset_endpoint_profile_ref: pulumi.Input[str],
                 discovery_id: pulumi.Input[str],
                 extended_location: pulumi.Input['ExtendedLocationArgs'],
                 resource_group_name: pulumi.Input[str],
                 version: pulumi.Input[float],
                 datasets: Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredDatasetArgs']]]] = None,
                 default_datasets_configuration: Optional[pulumi.Input[str]] = None,
                 default_events_configuration: Optional[pulumi.Input[str]] = None,
                 default_topic: Optional[pulumi.Input['TopicArgs']] = None,
                 discovered_asset_name: Optional[pulumi.Input[str]] = None,
                 documentation_uri: Optional[pulumi.Input[str]] = None,
                 events: Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredEventArgs']]]] = None,
                 hardware_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 manufacturer: Optional[pulumi.Input[str]] = None,
                 manufacturer_uri: Optional[pulumi.Input[str]] = None,
                 model: Optional[pulumi.Input[str]] = None,
                 product_code: Optional[pulumi.Input[str]] = None,
                 serial_number: Optional[pulumi.Input[str]] = None,
                 software_revision: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a DiscoveredAsset resource.
        :param pulumi.Input[str] asset_endpoint_profile_ref: A reference to the asset endpoint profile (connection information) used by brokers to connect to an endpoint that provides data points for this asset. Must provide asset endpoint profile name.
        :param pulumi.Input[str] discovery_id: Identifier used to detect changes in the asset.
        :param pulumi.Input['ExtendedLocationArgs'] extended_location: The extended location.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[float] version: An integer that is incremented each time the resource is modified.
        :param pulumi.Input[Sequence[pulumi.Input['DiscoveredDatasetArgs']]] datasets: Array of datasets that are part of the asset. Each dataset spec describes the data points that make up the set.
        :param pulumi.Input[str] default_datasets_configuration: Stringified JSON that contains connector-specific default configuration for all datasets. Each dataset can have its own configuration that overrides the default settings here.
        :param pulumi.Input[str] default_events_configuration: Stringified JSON that contains connector-specific default configuration for all events. Each event can have its own configuration that overrides the default settings here.
        :param pulumi.Input['TopicArgs'] default_topic: Object that describes the default topic information for the asset.
        :param pulumi.Input[str] discovered_asset_name: Discovered Asset name parameter.
        :param pulumi.Input[str] documentation_uri: Reference to the documentation.
        :param pulumi.Input[Sequence[pulumi.Input['DiscoveredEventArgs']]] events: Array of events that are part of the asset. Each event can have per-event configuration.
        :param pulumi.Input[str] hardware_revision: Revision number of the hardware.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] manufacturer: Asset manufacturer name.
        :param pulumi.Input[str] manufacturer_uri: Asset manufacturer URI.
        :param pulumi.Input[str] model: Asset model name.
        :param pulumi.Input[str] product_code: Asset product code.
        :param pulumi.Input[str] serial_number: Asset serial number.
        :param pulumi.Input[str] software_revision: Revision number of the software.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "asset_endpoint_profile_ref", asset_endpoint_profile_ref)
        pulumi.set(__self__, "discovery_id", discovery_id)
        pulumi.set(__self__, "extended_location", extended_location)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "version", version)
        if datasets is not None:
            pulumi.set(__self__, "datasets", datasets)
        if default_datasets_configuration is not None:
            pulumi.set(__self__, "default_datasets_configuration", default_datasets_configuration)
        if default_events_configuration is not None:
            pulumi.set(__self__, "default_events_configuration", default_events_configuration)
        if default_topic is not None:
            pulumi.set(__self__, "default_topic", default_topic)
        if discovered_asset_name is not None:
            pulumi.set(__self__, "discovered_asset_name", discovered_asset_name)
        if documentation_uri is not None:
            pulumi.set(__self__, "documentation_uri", documentation_uri)
        if events is not None:
            pulumi.set(__self__, "events", events)
        if hardware_revision is not None:
            pulumi.set(__self__, "hardware_revision", hardware_revision)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if manufacturer is not None:
            pulumi.set(__self__, "manufacturer", manufacturer)
        if manufacturer_uri is not None:
            pulumi.set(__self__, "manufacturer_uri", manufacturer_uri)
        if model is not None:
            pulumi.set(__self__, "model", model)
        if product_code is not None:
            pulumi.set(__self__, "product_code", product_code)
        if serial_number is not None:
            pulumi.set(__self__, "serial_number", serial_number)
        if software_revision is not None:
            pulumi.set(__self__, "software_revision", software_revision)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="assetEndpointProfileRef")
    def asset_endpoint_profile_ref(self) -> pulumi.Input[str]:
        """
        A reference to the asset endpoint profile (connection information) used by brokers to connect to an endpoint that provides data points for this asset. Must provide asset endpoint profile name.
        """
        return pulumi.get(self, "asset_endpoint_profile_ref")

    @asset_endpoint_profile_ref.setter
    def asset_endpoint_profile_ref(self, value: pulumi.Input[str]):
        pulumi.set(self, "asset_endpoint_profile_ref", value)

    @property
    @pulumi.getter(name="discoveryId")
    def discovery_id(self) -> pulumi.Input[str]:
        """
        Identifier used to detect changes in the asset.
        """
        return pulumi.get(self, "discovery_id")

    @discovery_id.setter
    def discovery_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "discovery_id", value)

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> pulumi.Input['ExtendedLocationArgs']:
        """
        The extended location.
        """
        return pulumi.get(self, "extended_location")

    @extended_location.setter
    def extended_location(self, value: pulumi.Input['ExtendedLocationArgs']):
        pulumi.set(self, "extended_location", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[float]:
        """
        An integer that is incremented each time the resource is modified.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[float]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def datasets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredDatasetArgs']]]]:
        """
        Array of datasets that are part of the asset. Each dataset spec describes the data points that make up the set.
        """
        return pulumi.get(self, "datasets")

    @datasets.setter
    def datasets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredDatasetArgs']]]]):
        pulumi.set(self, "datasets", value)

    @property
    @pulumi.getter(name="defaultDatasetsConfiguration")
    def default_datasets_configuration(self) -> Optional[pulumi.Input[str]]:
        """
        Stringified JSON that contains connector-specific default configuration for all datasets. Each dataset can have its own configuration that overrides the default settings here.
        """
        return pulumi.get(self, "default_datasets_configuration")

    @default_datasets_configuration.setter
    def default_datasets_configuration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_datasets_configuration", value)

    @property
    @pulumi.getter(name="defaultEventsConfiguration")
    def default_events_configuration(self) -> Optional[pulumi.Input[str]]:
        """
        Stringified JSON that contains connector-specific default configuration for all events. Each event can have its own configuration that overrides the default settings here.
        """
        return pulumi.get(self, "default_events_configuration")

    @default_events_configuration.setter
    def default_events_configuration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_events_configuration", value)

    @property
    @pulumi.getter(name="defaultTopic")
    def default_topic(self) -> Optional[pulumi.Input['TopicArgs']]:
        """
        Object that describes the default topic information for the asset.
        """
        return pulumi.get(self, "default_topic")

    @default_topic.setter
    def default_topic(self, value: Optional[pulumi.Input['TopicArgs']]):
        pulumi.set(self, "default_topic", value)

    @property
    @pulumi.getter(name="discoveredAssetName")
    def discovered_asset_name(self) -> Optional[pulumi.Input[str]]:
        """
        Discovered Asset name parameter.
        """
        return pulumi.get(self, "discovered_asset_name")

    @discovered_asset_name.setter
    def discovered_asset_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "discovered_asset_name", value)

    @property
    @pulumi.getter(name="documentationUri")
    def documentation_uri(self) -> Optional[pulumi.Input[str]]:
        """
        Reference to the documentation.
        """
        return pulumi.get(self, "documentation_uri")

    @documentation_uri.setter
    def documentation_uri(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "documentation_uri", value)

    @property
    @pulumi.getter
    def events(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredEventArgs']]]]:
        """
        Array of events that are part of the asset. Each event can have per-event configuration.
        """
        return pulumi.get(self, "events")

    @events.setter
    def events(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DiscoveredEventArgs']]]]):
        pulumi.set(self, "events", value)

    @property
    @pulumi.getter(name="hardwareRevision")
    def hardware_revision(self) -> Optional[pulumi.Input[str]]:
        """
        Revision number of the hardware.
        """
        return pulumi.get(self, "hardware_revision")

    @hardware_revision.setter
    def hardware_revision(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hardware_revision", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def manufacturer(self) -> Optional[pulumi.Input[str]]:
        """
        Asset manufacturer name.
        """
        return pulumi.get(self, "manufacturer")

    @manufacturer.setter
    def manufacturer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "manufacturer", value)

    @property
    @pulumi.getter(name="manufacturerUri")
    def manufacturer_uri(self) -> Optional[pulumi.Input[str]]:
        """
        Asset manufacturer URI.
        """
        return pulumi.get(self, "manufacturer_uri")

    @manufacturer_uri.setter
    def manufacturer_uri(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "manufacturer_uri", value)

    @property
    @pulumi.getter
    def model(self) -> Optional[pulumi.Input[str]]:
        """
        Asset model name.
        """
        return pulumi.get(self, "model")

    @model.setter
    def model(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "model", value)

    @property
    @pulumi.getter(name="productCode")
    def product_code(self) -> Optional[pulumi.Input[str]]:
        """
        Asset product code.
        """
        return pulumi.get(self, "product_code")

    @product_code.setter
    def product_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "product_code", value)

    @property
    @pulumi.getter(name="serialNumber")
    def serial_number(self) -> Optional[pulumi.Input[str]]:
        """
        Asset serial number.
        """
        return pulumi.get(self, "serial_number")

    @serial_number.setter
    def serial_number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "serial_number", value)

    @property
    @pulumi.getter(name="softwareRevision")
    def software_revision(self) -> Optional[pulumi.Input[str]]:
        """
        Revision number of the software.
        """
        return pulumi.get(self, "software_revision")

    @software_revision.setter
    def software_revision(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "software_revision", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


class DiscoveredAsset(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 asset_endpoint_profile_ref: Optional[pulumi.Input[str]] = None,
                 datasets: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredDatasetArgs', 'DiscoveredDatasetArgsDict']]]]] = None,
                 default_datasets_configuration: Optional[pulumi.Input[str]] = None,
                 default_events_configuration: Optional[pulumi.Input[str]] = None,
                 default_topic: Optional[pulumi.Input[Union['TopicArgs', 'TopicArgsDict']]] = None,
                 discovered_asset_name: Optional[pulumi.Input[str]] = None,
                 discovery_id: Optional[pulumi.Input[str]] = None,
                 documentation_uri: Optional[pulumi.Input[str]] = None,
                 events: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredEventArgs', 'DiscoveredEventArgsDict']]]]] = None,
                 extended_location: Optional[pulumi.Input[Union['ExtendedLocationArgs', 'ExtendedLocationArgsDict']]] = None,
                 hardware_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 manufacturer: Optional[pulumi.Input[str]] = None,
                 manufacturer_uri: Optional[pulumi.Input[str]] = None,
                 model: Optional[pulumi.Input[str]] = None,
                 product_code: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 serial_number: Optional[pulumi.Input[str]] = None,
                 software_revision: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 version: Optional[pulumi.Input[float]] = None,
                 __props__=None):
        """
        Discovered Asset definition.

        Uses Azure REST API version 2024-09-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-09-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] asset_endpoint_profile_ref: A reference to the asset endpoint profile (connection information) used by brokers to connect to an endpoint that provides data points for this asset. Must provide asset endpoint profile name.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredDatasetArgs', 'DiscoveredDatasetArgsDict']]]] datasets: Array of datasets that are part of the asset. Each dataset spec describes the data points that make up the set.
        :param pulumi.Input[str] default_datasets_configuration: Stringified JSON that contains connector-specific default configuration for all datasets. Each dataset can have its own configuration that overrides the default settings here.
        :param pulumi.Input[str] default_events_configuration: Stringified JSON that contains connector-specific default configuration for all events. Each event can have its own configuration that overrides the default settings here.
        :param pulumi.Input[Union['TopicArgs', 'TopicArgsDict']] default_topic: Object that describes the default topic information for the asset.
        :param pulumi.Input[str] discovered_asset_name: Discovered Asset name parameter.
        :param pulumi.Input[str] discovery_id: Identifier used to detect changes in the asset.
        :param pulumi.Input[str] documentation_uri: Reference to the documentation.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredEventArgs', 'DiscoveredEventArgsDict']]]] events: Array of events that are part of the asset. Each event can have per-event configuration.
        :param pulumi.Input[Union['ExtendedLocationArgs', 'ExtendedLocationArgsDict']] extended_location: The extended location.
        :param pulumi.Input[str] hardware_revision: Revision number of the hardware.
        :param pulumi.Input[str] location: The geo-location where the resource lives
        :param pulumi.Input[str] manufacturer: Asset manufacturer name.
        :param pulumi.Input[str] manufacturer_uri: Asset manufacturer URI.
        :param pulumi.Input[str] model: Asset model name.
        :param pulumi.Input[str] product_code: Asset product code.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] serial_number: Asset serial number.
        :param pulumi.Input[str] software_revision: Revision number of the software.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Resource tags.
        :param pulumi.Input[float] version: An integer that is incremented each time the resource is modified.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DiscoveredAssetArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Discovered Asset definition.

        Uses Azure REST API version 2024-09-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-09-01-preview.

        :param str resource_name: The name of the resource.
        :param DiscoveredAssetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DiscoveredAssetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 asset_endpoint_profile_ref: Optional[pulumi.Input[str]] = None,
                 datasets: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredDatasetArgs', 'DiscoveredDatasetArgsDict']]]]] = None,
                 default_datasets_configuration: Optional[pulumi.Input[str]] = None,
                 default_events_configuration: Optional[pulumi.Input[str]] = None,
                 default_topic: Optional[pulumi.Input[Union['TopicArgs', 'TopicArgsDict']]] = None,
                 discovered_asset_name: Optional[pulumi.Input[str]] = None,
                 discovery_id: Optional[pulumi.Input[str]] = None,
                 documentation_uri: Optional[pulumi.Input[str]] = None,
                 events: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DiscoveredEventArgs', 'DiscoveredEventArgsDict']]]]] = None,
                 extended_location: Optional[pulumi.Input[Union['ExtendedLocationArgs', 'ExtendedLocationArgsDict']]] = None,
                 hardware_revision: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 manufacturer: Optional[pulumi.Input[str]] = None,
                 manufacturer_uri: Optional[pulumi.Input[str]] = None,
                 model: Optional[pulumi.Input[str]] = None,
                 product_code: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 serial_number: Optional[pulumi.Input[str]] = None,
                 software_revision: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 version: Optional[pulumi.Input[float]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DiscoveredAssetArgs.__new__(DiscoveredAssetArgs)

            if asset_endpoint_profile_ref is None and not opts.urn:
                raise TypeError("Missing required property 'asset_endpoint_profile_ref'")
            __props__.__dict__["asset_endpoint_profile_ref"] = asset_endpoint_profile_ref
            __props__.__dict__["datasets"] = datasets
            __props__.__dict__["default_datasets_configuration"] = default_datasets_configuration
            __props__.__dict__["default_events_configuration"] = default_events_configuration
            __props__.__dict__["default_topic"] = default_topic
            __props__.__dict__["discovered_asset_name"] = discovered_asset_name
            if discovery_id is None and not opts.urn:
                raise TypeError("Missing required property 'discovery_id'")
            __props__.__dict__["discovery_id"] = discovery_id
            __props__.__dict__["documentation_uri"] = documentation_uri
            __props__.__dict__["events"] = events
            if extended_location is None and not opts.urn:
                raise TypeError("Missing required property 'extended_location'")
            __props__.__dict__["extended_location"] = extended_location
            __props__.__dict__["hardware_revision"] = hardware_revision
            __props__.__dict__["location"] = location
            __props__.__dict__["manufacturer"] = manufacturer
            __props__.__dict__["manufacturer_uri"] = manufacturer_uri
            __props__.__dict__["model"] = model
            __props__.__dict__["product_code"] = product_code
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["serial_number"] = serial_number
            __props__.__dict__["software_revision"] = software_revision
            __props__.__dict__["tags"] = tags
            if version is None and not opts.urn:
                raise TypeError("Missing required property 'version'")
            __props__.__dict__["version"] = version
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:deviceregistry/v20240901preview:DiscoveredAsset")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(DiscoveredAsset, __self__).__init__(
            'azure-native:deviceregistry:DiscoveredAsset',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DiscoveredAsset':
        """
        Get an existing DiscoveredAsset resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DiscoveredAssetArgs.__new__(DiscoveredAssetArgs)

        __props__.__dict__["asset_endpoint_profile_ref"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["datasets"] = None
        __props__.__dict__["default_datasets_configuration"] = None
        __props__.__dict__["default_events_configuration"] = None
        __props__.__dict__["default_topic"] = None
        __props__.__dict__["discovery_id"] = None
        __props__.__dict__["documentation_uri"] = None
        __props__.__dict__["events"] = None
        __props__.__dict__["extended_location"] = None
        __props__.__dict__["hardware_revision"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["manufacturer"] = None
        __props__.__dict__["manufacturer_uri"] = None
        __props__.__dict__["model"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["product_code"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["serial_number"] = None
        __props__.__dict__["software_revision"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["version"] = None
        return DiscoveredAsset(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assetEndpointProfileRef")
    def asset_endpoint_profile_ref(self) -> pulumi.Output[str]:
        """
        A reference to the asset endpoint profile (connection information) used by brokers to connect to an endpoint that provides data points for this asset. Must provide asset endpoint profile name.
        """
        return pulumi.get(self, "asset_endpoint_profile_ref")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def datasets(self) -> pulumi.Output[Optional[Sequence['outputs.DiscoveredDatasetResponse']]]:
        """
        Array of datasets that are part of the asset. Each dataset spec describes the data points that make up the set.
        """
        return pulumi.get(self, "datasets")

    @property
    @pulumi.getter(name="defaultDatasetsConfiguration")
    def default_datasets_configuration(self) -> pulumi.Output[Optional[str]]:
        """
        Stringified JSON that contains connector-specific default configuration for all datasets. Each dataset can have its own configuration that overrides the default settings here.
        """
        return pulumi.get(self, "default_datasets_configuration")

    @property
    @pulumi.getter(name="defaultEventsConfiguration")
    def default_events_configuration(self) -> pulumi.Output[Optional[str]]:
        """
        Stringified JSON that contains connector-specific default configuration for all events. Each event can have its own configuration that overrides the default settings here.
        """
        return pulumi.get(self, "default_events_configuration")

    @property
    @pulumi.getter(name="defaultTopic")
    def default_topic(self) -> pulumi.Output[Optional['outputs.TopicResponse']]:
        """
        Object that describes the default topic information for the asset.
        """
        return pulumi.get(self, "default_topic")

    @property
    @pulumi.getter(name="discoveryId")
    def discovery_id(self) -> pulumi.Output[str]:
        """
        Identifier used to detect changes in the asset.
        """
        return pulumi.get(self, "discovery_id")

    @property
    @pulumi.getter(name="documentationUri")
    def documentation_uri(self) -> pulumi.Output[Optional[str]]:
        """
        Reference to the documentation.
        """
        return pulumi.get(self, "documentation_uri")

    @property
    @pulumi.getter
    def events(self) -> pulumi.Output[Optional[Sequence['outputs.DiscoveredEventResponse']]]:
        """
        Array of events that are part of the asset. Each event can have per-event configuration.
        """
        return pulumi.get(self, "events")

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> pulumi.Output['outputs.ExtendedLocationResponse']:
        """
        The extended location.
        """
        return pulumi.get(self, "extended_location")

    @property
    @pulumi.getter(name="hardwareRevision")
    def hardware_revision(self) -> pulumi.Output[Optional[str]]:
        """
        Revision number of the hardware.
        """
        return pulumi.get(self, "hardware_revision")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def manufacturer(self) -> pulumi.Output[Optional[str]]:
        """
        Asset manufacturer name.
        """
        return pulumi.get(self, "manufacturer")

    @property
    @pulumi.getter(name="manufacturerUri")
    def manufacturer_uri(self) -> pulumi.Output[Optional[str]]:
        """
        Asset manufacturer URI.
        """
        return pulumi.get(self, "manufacturer_uri")

    @property
    @pulumi.getter
    def model(self) -> pulumi.Output[Optional[str]]:
        """
        Asset model name.
        """
        return pulumi.get(self, "model")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="productCode")
    def product_code(self) -> pulumi.Output[Optional[str]]:
        """
        Asset product code.
        """
        return pulumi.get(self, "product_code")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        Provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="serialNumber")
    def serial_number(self) -> pulumi.Output[Optional[str]]:
        """
        Asset serial number.
        """
        return pulumi.get(self, "serial_number")

    @property
    @pulumi.getter(name="softwareRevision")
    def software_revision(self) -> pulumi.Output[Optional[str]]:
        """
        Revision number of the software.
        """
        return pulumi.get(self, "software_revision")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[float]:
        """
        An integer that is incremented each time the resource is modified.
        """
        return pulumi.get(self, "version")

