# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListDnsResolverPolicyByVirtualNetworkResult',
    'AwaitableListDnsResolverPolicyByVirtualNetworkResult',
    'list_dns_resolver_policy_by_virtual_network',
    'list_dns_resolver_policy_by_virtual_network_output',
]

@pulumi.output_type
class ListDnsResolverPolicyByVirtualNetworkResult:
    """
    The response to an enumeration operation on sub-resources.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> str:
        """
        The continuation token for the next page of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.SubResourceResponse']]:
        """
        Enumeration of the sub-resources.
        """
        return pulumi.get(self, "value")


class AwaitableListDnsResolverPolicyByVirtualNetworkResult(ListDnsResolverPolicyByVirtualNetworkResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListDnsResolverPolicyByVirtualNetworkResult(
            next_link=self.next_link,
            value=self.value)


def list_dns_resolver_policy_by_virtual_network(resource_group_name: Optional[str] = None,
                                                virtual_network_name: Optional[str] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListDnsResolverPolicyByVirtualNetworkResult:
    """
    Lists DNS resolver policy resource IDs linked to a virtual network.

    Uses Azure REST API version 2023-07-01-preview.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str virtual_network_name: The name of the virtual network.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualNetworkName'] = virtual_network_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:dnsresolver:listDnsResolverPolicyByVirtualNetwork', __args__, opts=opts, typ=ListDnsResolverPolicyByVirtualNetworkResult).value

    return AwaitableListDnsResolverPolicyByVirtualNetworkResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_dns_resolver_policy_by_virtual_network_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                                                       virtual_network_name: Optional[pulumi.Input[str]] = None,
                                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListDnsResolverPolicyByVirtualNetworkResult]:
    """
    Lists DNS resolver policy resource IDs linked to a virtual network.

    Uses Azure REST API version 2023-07-01-preview.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str virtual_network_name: The name of the virtual network.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualNetworkName'] = virtual_network_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:dnsresolver:listDnsResolverPolicyByVirtualNetwork', __args__, opts=opts, typ=ListDnsResolverPolicyByVirtualNetworkResult)
    return __ret__.apply(lambda __response__: ListDnsResolverPolicyByVirtualNetworkResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
