# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'SchedulerPropertiesArgs',
    'SchedulerPropertiesArgsDict',
    'SchedulerSkuArgs',
    'SchedulerSkuArgsDict',
]

MYPY = False

if not MYPY:
    class SchedulerPropertiesArgsDict(TypedDict):
        """
        Details of the Scheduler
        """
        ip_allowlist: pulumi.Input[Sequence[pulumi.Input[str]]]
        """
        IP allow list for durable task scheduler. Values can be IPv4, IPv6 or CIDR
        """
        sku: pulumi.Input['SchedulerSkuArgsDict']
        """
        SKU of the durable task scheduler
        """
elif False:
    SchedulerPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SchedulerPropertiesArgs:
    def __init__(__self__, *,
                 ip_allowlist: pulumi.Input[Sequence[pulumi.Input[str]]],
                 sku: pulumi.Input['SchedulerSkuArgs']):
        """
        Details of the Scheduler
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ip_allowlist: IP allow list for durable task scheduler. Values can be IPv4, IPv6 or CIDR
        :param pulumi.Input['SchedulerSkuArgs'] sku: SKU of the durable task scheduler
        """
        pulumi.set(__self__, "ip_allowlist", ip_allowlist)
        pulumi.set(__self__, "sku", sku)

    @property
    @pulumi.getter(name="ipAllowlist")
    def ip_allowlist(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        IP allow list for durable task scheduler. Values can be IPv4, IPv6 or CIDR
        """
        return pulumi.get(self, "ip_allowlist")

    @ip_allowlist.setter
    def ip_allowlist(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "ip_allowlist", value)

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Input['SchedulerSkuArgs']:
        """
        SKU of the durable task scheduler
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: pulumi.Input['SchedulerSkuArgs']):
        pulumi.set(self, "sku", value)


if not MYPY:
    class SchedulerSkuArgsDict(TypedDict):
        """
        The SKU (Stock Keeping Unit) assigned to this durable task scheduler
        """
        name: pulumi.Input[str]
        """
        The name of the SKU
        """
        capacity: NotRequired[pulumi.Input[int]]
        """
        The SKU capacity. This allows scale out/in for the resource and impacts zone redundancy
        """
elif False:
    SchedulerSkuArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SchedulerSkuArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 capacity: Optional[pulumi.Input[int]] = None):
        """
        The SKU (Stock Keeping Unit) assigned to this durable task scheduler
        :param pulumi.Input[str] name: The name of the SKU
        :param pulumi.Input[int] capacity: The SKU capacity. This allows scale out/in for the resource and impacts zone redundancy
        """
        pulumi.set(__self__, "name", name)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        The name of the SKU
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def capacity(self) -> Optional[pulumi.Input[int]]:
        """
        The SKU capacity. This allows scale out/in for the resource and impacts zone redundancy
        """
        return pulumi.get(self, "capacity")

    @capacity.setter
    def capacity(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "capacity", value)


