# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'SchedulerPropertiesResponse',
    'SchedulerSkuResponse',
    'SystemDataResponse',
    'TaskHubPropertiesResponse',
]

@pulumi.output_type
class SchedulerPropertiesResponse(dict):
    """
    Details of the Scheduler
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipAllowlist":
            suggest = "ip_allowlist"
        elif key == "provisioningState":
            suggest = "provisioning_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SchedulerPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SchedulerPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SchedulerPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 endpoint: str,
                 ip_allowlist: Sequence[str],
                 provisioning_state: str,
                 sku: 'outputs.SchedulerSkuResponse'):
        """
        Details of the Scheduler
        :param str endpoint: URL of the durable task scheduler
        :param Sequence[str] ip_allowlist: IP allow list for durable task scheduler. Values can be IPv4, IPv6 or CIDR
        :param str provisioning_state: The status of the last operation
        :param 'SchedulerSkuResponse' sku: SKU of the durable task scheduler
        """
        pulumi.set(__self__, "endpoint", endpoint)
        pulumi.set(__self__, "ip_allowlist", ip_allowlist)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "sku", sku)

    @property
    @pulumi.getter
    def endpoint(self) -> str:
        """
        URL of the durable task scheduler
        """
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter(name="ipAllowlist")
    def ip_allowlist(self) -> Sequence[str]:
        """
        IP allow list for durable task scheduler. Values can be IPv4, IPv6 or CIDR
        """
        return pulumi.get(self, "ip_allowlist")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The status of the last operation
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def sku(self) -> 'outputs.SchedulerSkuResponse':
        """
        SKU of the durable task scheduler
        """
        return pulumi.get(self, "sku")


@pulumi.output_type
class SchedulerSkuResponse(dict):
    """
    The SKU (Stock Keeping Unit) assigned to this durable task scheduler
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "redundancyState":
            suggest = "redundancy_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SchedulerSkuResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SchedulerSkuResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SchedulerSkuResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 redundancy_state: str,
                 capacity: Optional[int] = None):
        """
        The SKU (Stock Keeping Unit) assigned to this durable task scheduler
        :param str name: The name of the SKU
        :param str redundancy_state: Indicates whether the current SKU configuration is zone redundant
        :param int capacity: The SKU capacity. This allows scale out/in for the resource and impacts zone redundancy
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "redundancy_state", redundancy_state)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the SKU
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="redundancyState")
    def redundancy_state(self) -> str:
        """
        Indicates whether the current SKU configuration is zone redundant
        """
        return pulumi.get(self, "redundancy_state")

    @property
    @pulumi.getter
    def capacity(self) -> Optional[int]:
        """
        The SKU capacity. This allows scale out/in for the resource and impacts zone redundancy
        """
        return pulumi.get(self, "capacity")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class TaskHubPropertiesResponse(dict):
    """
    The properties of Task Hub
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dashboardUrl":
            suggest = "dashboard_url"
        elif key == "provisioningState":
            suggest = "provisioning_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TaskHubPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TaskHubPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TaskHubPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dashboard_url: str,
                 provisioning_state: str):
        """
        The properties of Task Hub
        :param str dashboard_url: URL of the durable task scheduler dashboard
        :param str provisioning_state: The status of the last operation
        """
        pulumi.set(__self__, "dashboard_url", dashboard_url)
        pulumi.set(__self__, "provisioning_state", provisioning_state)

    @property
    @pulumi.getter(name="dashboardUrl")
    def dashboard_url(self) -> str:
        """
        URL of the durable task scheduler dashboard
        """
        return pulumi.get(self, "dashboard_url")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> str:
        """
        The status of the last operation
        """
        return pulumi.get(self, "provisioning_state")


