# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListUpgradableVersionDetailsResult',
    'AwaitableListUpgradableVersionDetailsResult',
    'list_upgradable_version_details',
    'list_upgradable_version_details_output',
]

@pulumi.output_type
class ListUpgradableVersionDetailsResult:
    """
    Stack Versions that this version can upgrade to
    """
    def __init__(__self__, current_version=None, upgradable_versions=None):
        if current_version and not isinstance(current_version, str):
            raise TypeError("Expected argument 'current_version' to be a str")
        pulumi.set(__self__, "current_version", current_version)
        if upgradable_versions and not isinstance(upgradable_versions, list):
            raise TypeError("Expected argument 'upgradable_versions' to be a list")
        pulumi.set(__self__, "upgradable_versions", upgradable_versions)

    @property
    @pulumi.getter(name="currentVersion")
    def current_version(self) -> Optional[str]:
        """
        Current version of the elastic monitor
        """
        return pulumi.get(self, "current_version")

    @property
    @pulumi.getter(name="upgradableVersions")
    def upgradable_versions(self) -> Optional[Sequence[str]]:
        """
        Stack Versions that this version can upgrade to
        """
        return pulumi.get(self, "upgradable_versions")


class AwaitableListUpgradableVersionDetailsResult(ListUpgradableVersionDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListUpgradableVersionDetailsResult(
            current_version=self.current_version,
            upgradable_versions=self.upgradable_versions)


def list_upgradable_version_details(monitor_name: Optional[str] = None,
                                    resource_group_name: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListUpgradableVersionDetailsResult:
    """
    Stack Versions that this version can upgrade to

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-06-01, 2023-06-15-preview, 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str monitor_name: Monitor resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:elastic:listUpgradableVersionDetails', __args__, opts=opts, typ=ListUpgradableVersionDetailsResult).value

    return AwaitableListUpgradableVersionDetailsResult(
        current_version=pulumi.get(__ret__, 'current_version'),
        upgradable_versions=pulumi.get(__ret__, 'upgradable_versions'))
def list_upgradable_version_details_output(monitor_name: Optional[pulumi.Input[str]] = None,
                                           resource_group_name: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListUpgradableVersionDetailsResult]:
    """
    Stack Versions that this version can upgrade to

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-06-01, 2023-06-15-preview, 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str monitor_name: Monitor resource name
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:elastic:listUpgradableVersionDetails', __args__, opts=opts, typ=ListUpgradableVersionDetailsResult)
    return __ret__.apply(lambda __response__: ListUpgradableVersionDetailsResult(
        current_version=pulumi.get(__response__, 'current_version'),
        upgradable_versions=pulumi.get(__response__, 'upgradable_versions')))
