# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AutoscaleType',
    'ComparisonOperator',
    'ContentEncoding',
    'DataDiskType',
    'DaysOfWeek',
    'DbConnectionAuthenticationMode',
    'DeploymentMode',
    'DirectoryType',
    'JsonWebKeyEncryptionAlgorithm',
    'KeyVaultObjectType',
    'ManagedIdentityType',
    'MetastoreDbConnectionAuthenticationMode',
    'OSType',
    'OutboundDependenciesManagedType',
    'OutboundType',
    'PrivateIPAllocationMethod',
    'PrivateLink',
    'PrivateLinkServiceConnectionStatus',
    'RangerUsersyncMode',
    'ResourceIdentityType',
    'ResourceProviderConnection',
    'ScaleActionType',
    'ScheduleDay',
    'Tier',
    'UpgradeMode',
]


class AutoscaleType(str, Enum):
    """
    User to specify which type of Autoscale to be implemented - Scheduled Based or Load Based.
    """
    SCHEDULE_BASED = "ScheduleBased"
    LOAD_BASED = "LoadBased"


class ComparisonOperator(str, Enum):
    """
    The comparison operator.
    """
    GREATER_THAN = "greaterThan"
    GREATER_THAN_OR_EQUAL = "greaterThanOrEqual"
    LESS_THAN = "lessThan"
    LESS_THAN_OR_EQUAL = "lessThanOrEqual"


class ContentEncoding(str, Enum):
    """
    This property indicates if the content is encoded and is case-insensitive. Please set the value to base64 if the content is base64 encoded. Set it to none or skip it if the content is plain text.
    """
    BASE64 = "Base64"
    NONE = "None"


class DataDiskType(str, Enum):
    """
    Managed Disk Type.
    """
    STANDARD_HD_D_LRS = "Standard_HDD_LRS"
    STANDARD_SS_D_LRS = "Standard_SSD_LRS"
    STANDARD_SS_D_ZRS = "Standard_SSD_ZRS"
    PREMIUM_SS_D_LRS = "Premium_SSD_LRS"
    PREMIUM_SS_D_ZRS = "Premium_SSD_ZRS"
    PREMIUM_SS_D_V2_LRS = "Premium_SSD_v2_LRS"


class DaysOfWeek(str, Enum):
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"


class DbConnectionAuthenticationMode(str, Enum):
    """
    The authentication mode to connect to your Hive metastore database. More details: https://learn.microsoft.com/en-us/azure/azure-sql/database/logins-create-manage?view=azuresql#authentication-and-authorization
    """
    SQL_AUTH = "SqlAuth"
    """
    The password-based authentication to connect to your Hive metastore database. 
    """
    IDENTITY_AUTH = "IdentityAuth"
    """
    The managed-identity-based authentication to connect to your Hive metastore database. 
    """


class DeploymentMode(str, Enum):
    """
    A string property that indicates the deployment mode of Flink cluster. It can have one of the following enum values => Application, Session. Default value is Session
    """
    APPLICATION = "Application"
    SESSION = "Session"


class DirectoryType(str, Enum):
    """
    The directory type.
    """
    ACTIVE_DIRECTORY = "ActiveDirectory"


class JsonWebKeyEncryptionAlgorithm(str, Enum):
    """
    Algorithm identifier for encryption, default RSA-OAEP.
    """
    RS_A_OAEP = "RSA-OAEP"
    RS_A_OAE_P_256 = "RSA-OAEP-256"
    RSA1_5 = "RSA1_5"


class KeyVaultObjectType(str, Enum):
    """
    Type of key vault object: secret, key or certificate.
    """
    KEY = "Key"
    SECRET = "Secret"
    CERTIFICATE = "Certificate"


class ManagedIdentityType(str, Enum):
    """
    The type of managed identity.
    """
    CLUSTER = "cluster"
    USER = "user"
    INTERNAL = "internal"


class MetastoreDbConnectionAuthenticationMode(str, Enum):
    """
    The authentication mode to connect to your Hive metastore database. More details: https://learn.microsoft.com/en-us/azure/azure-sql/database/logins-create-manage?view=azuresql#authentication-and-authorization
    """
    SQL_AUTH = "SqlAuth"
    """
    The password-based authentication to connect to your Hive metastore database. 
    """
    IDENTITY_AUTH = "IdentityAuth"
    """
    The managed-identity-based authentication to connect to your Hive metastore database. 
    """


class OSType(str, Enum):
    """
    The type of operating system.
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


class OutboundDependenciesManagedType(str, Enum):
    """
    A value to describe how the outbound dependencies of a HDInsight cluster are managed. 'Managed' means that the outbound dependencies are managed by the HDInsight service. 'External' means that the outbound dependencies are managed by a customer specific solution.
    """
    MANAGED = "Managed"
    EXTERNAL = "External"


class OutboundType(str, Enum):
    """
    This can only be set at cluster pool creation time and cannot be changed later. 
    """
    LOAD_BALANCER = "loadBalancer"
    """
    The load balancer is used for egress through an AKS assigned public IP. This supports Kubernetes services of type 'loadBalancer'. 
    """
    USER_DEFINED_ROUTING = "userDefinedRouting"
    """
    Egress paths must be defined by the user. This is an advanced scenario and requires proper network configuration. 
    """


class PrivateIPAllocationMethod(str, Enum):
    """
    The method that private IP address is allocated.
    """
    DYNAMIC = "dynamic"
    STATIC = "static"


class PrivateLink(str, Enum):
    """
    Indicates whether or not private link is enabled.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


class PrivateLinkServiceConnectionStatus(str, Enum):
    """
    The concrete private link service connection.
    """
    APPROVED = "Approved"
    REJECTED = "Rejected"
    PENDING = "Pending"
    REMOVED = "Removed"


class RangerUsersyncMode(str, Enum):
    """
    User & groups can be synced automatically or via a static list that's refreshed.
    """
    STATIC = "static"
    AUTOMATIC = "automatic"


class ResourceIdentityType(str, Enum):
    """
    The type of identity used for the cluster. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


class ResourceProviderConnection(str, Enum):
    """
    The direction for the resource provider connection.
    """
    INBOUND = "Inbound"
    OUTBOUND = "Outbound"


class ScaleActionType(str, Enum):
    """
    The action type.
    """
    SCALEUP = "scaleup"
    SCALEDOWN = "scaledown"


class ScheduleDay(str, Enum):
    SUNDAY = "Sunday"
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"


class Tier(str, Enum):
    """
    The cluster tier.
    """
    STANDARD = "Standard"
    PREMIUM = "Premium"


class UpgradeMode(str, Enum):
    """
    A string property that indicates the upgrade mode to be performed on the Flink job. It can have one of the following enum values => STATELESS_UPDATE, UPDATE, LAST_STATE_UPDATE.
    """
    STATELES_S_UPDATE = "STATELESS_UPDATE"
    UPDATE = "UPDATE"
    LAS_T_STAT_E_UPDATE = "LAST_STATE_UPDATE"
