# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = ['SolutionConfigurationArgs', 'SolutionConfiguration']

@pulumi.input_type
class SolutionConfigurationArgs:
    def __init__(__self__, *,
                 resource_uri: pulumi.Input[str],
                 solution_type: pulumi.Input[str],
                 solution_configuration: Optional[pulumi.Input[str]] = None,
                 solution_settings: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a SolutionConfiguration resource.
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[str] solution_type: The type of the solution
        :param pulumi.Input[str] solution_configuration: Represent Solution Configuration Resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] solution_settings: Solution settings
        """
        pulumi.set(__self__, "resource_uri", resource_uri)
        pulumi.set(__self__, "solution_type", solution_type)
        if solution_configuration is not None:
            pulumi.set(__self__, "solution_configuration", solution_configuration)
        if solution_settings is not None:
            pulumi.set(__self__, "solution_settings", solution_settings)

    @property
    @pulumi.getter(name="resourceUri")
    def resource_uri(self) -> pulumi.Input[str]:
        """
        The fully qualified Azure Resource manager identifier of the resource.
        """
        return pulumi.get(self, "resource_uri")

    @resource_uri.setter
    def resource_uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_uri", value)

    @property
    @pulumi.getter(name="solutionType")
    def solution_type(self) -> pulumi.Input[str]:
        """
        The type of the solution
        """
        return pulumi.get(self, "solution_type")

    @solution_type.setter
    def solution_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "solution_type", value)

    @property
    @pulumi.getter(name="solutionConfiguration")
    def solution_configuration(self) -> Optional[pulumi.Input[str]]:
        """
        Represent Solution Configuration Resource.
        """
        return pulumi.get(self, "solution_configuration")

    @solution_configuration.setter
    def solution_configuration(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "solution_configuration", value)

    @property
    @pulumi.getter(name="solutionSettings")
    def solution_settings(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Solution settings
        """
        return pulumi.get(self, "solution_settings")

    @solution_settings.setter
    def solution_settings(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "solution_settings", value)


class SolutionConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 solution_configuration: Optional[pulumi.Input[str]] = None,
                 solution_settings: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 solution_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Solution Configuration

        Uses Azure REST API version 2024-12-01. In version 2.x of the Azure Native provider, it used API version 2024-12-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[str] solution_configuration: Represent Solution Configuration Resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] solution_settings: Solution settings
        :param pulumi.Input[str] solution_type: The type of the solution
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SolutionConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Solution Configuration

        Uses Azure REST API version 2024-12-01. In version 2.x of the Azure Native provider, it used API version 2024-12-01.

        :param str resource_name: The name of the resource.
        :param SolutionConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SolutionConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 solution_configuration: Optional[pulumi.Input[str]] = None,
                 solution_settings: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 solution_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SolutionConfigurationArgs.__new__(SolutionConfigurationArgs)

            if resource_uri is None and not opts.urn:
                raise TypeError("Missing required property 'resource_uri'")
            __props__.__dict__["resource_uri"] = resource_uri
            __props__.__dict__["solution_configuration"] = solution_configuration
            __props__.__dict__["solution_settings"] = solution_settings
            if solution_type is None and not opts.urn:
                raise TypeError("Missing required property 'solution_type'")
            __props__.__dict__["solution_type"] = solution_type
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["last_sync_time"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["status_details"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:hybridconnectivity/v20241201:SolutionConfiguration")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(SolutionConfiguration, __self__).__init__(
            'azure-native:hybridconnectivity:SolutionConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'SolutionConfiguration':
        """
        Get an existing SolutionConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = SolutionConfigurationArgs.__new__(SolutionConfigurationArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["last_sync_time"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["solution_settings"] = None
        __props__.__dict__["solution_type"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["status_details"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return SolutionConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="lastSyncTime")
    def last_sync_time(self) -> pulumi.Output[str]:
        """
        The last time resources were inventoried
        """
        return pulumi.get(self, "last_sync_time")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The resource provisioning state.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="solutionSettings")
    def solution_settings(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Solution settings
        """
        return pulumi.get(self, "solution_settings")

    @property
    @pulumi.getter(name="solutionType")
    def solution_type(self) -> pulumi.Output[str]:
        """
        The type of the solution
        """
        return pulumi.get(self, "solution_type")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The status of solution configurations
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="statusDetails")
    def status_details(self) -> pulumi.Output[str]:
        """
        The detailed message of status details
        """
        return pulumi.get(self, "status_details")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

