# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InsightArgs', 'Insight']

@pulumi.input_type
class InsightArgs:
    def __init__(__self__, *,
                 workload_impact_name: pulumi.Input[str],
                 insight_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input['InsightPropertiesArgs']] = None):
        """
        The set of arguments for constructing a Insight resource.
        :param pulumi.Input[str] workload_impact_name: workloadImpact resource 
        :param pulumi.Input[str] insight_name: Name of the insight
        :param pulumi.Input['InsightPropertiesArgs'] properties: The resource-specific properties for this resource.
        """
        pulumi.set(__self__, "workload_impact_name", workload_impact_name)
        if insight_name is not None:
            pulumi.set(__self__, "insight_name", insight_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter(name="workloadImpactName")
    def workload_impact_name(self) -> pulumi.Input[str]:
        """
        workloadImpact resource 
        """
        return pulumi.get(self, "workload_impact_name")

    @workload_impact_name.setter
    def workload_impact_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "workload_impact_name", value)

    @property
    @pulumi.getter(name="insightName")
    def insight_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the insight
        """
        return pulumi.get(self, "insight_name")

    @insight_name.setter
    def insight_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "insight_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['InsightPropertiesArgs']]:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['InsightPropertiesArgs']]):
        pulumi.set(self, "properties", value)


class Insight(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 insight_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[Union['InsightPropertiesArgs', 'InsightPropertiesArgsDict']]] = None,
                 workload_impact_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Insight resource

        Uses Azure REST API version 2024-05-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-05-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] insight_name: Name of the insight
        :param pulumi.Input[Union['InsightPropertiesArgs', 'InsightPropertiesArgsDict']] properties: The resource-specific properties for this resource.
        :param pulumi.Input[str] workload_impact_name: workloadImpact resource 
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InsightArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Insight resource

        Uses Azure REST API version 2024-05-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-05-01-preview.

        :param str resource_name: The name of the resource.
        :param InsightArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InsightArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 insight_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[Union['InsightPropertiesArgs', 'InsightPropertiesArgsDict']]] = None,
                 workload_impact_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InsightArgs.__new__(InsightArgs)

            __props__.__dict__["insight_name"] = insight_name
            __props__.__dict__["properties"] = properties
            if workload_impact_name is None and not opts.urn:
                raise TypeError("Missing required property 'workload_impact_name'")
            __props__.__dict__["workload_impact_name"] = workload_impact_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:impact/v20240501preview:Insight")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(Insight, __self__).__init__(
            'azure-native:impact:Insight',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Insight':
        """
        Get an existing Insight resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = InsightArgs.__new__(InsightArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return Insight(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.InsightPropertiesResponse']:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

