# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListBitLockerKeyResult',
    'AwaitableListBitLockerKeyResult',
    'list_bit_locker_key',
    'list_bit_locker_key_output',
]

@pulumi.output_type
class ListBitLockerKeyResult:
    """
    GetBitLockerKeys response
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.DriveBitLockerKeyResponse']]:
        """
        drive status
        """
        return pulumi.get(self, "value")


class AwaitableListBitLockerKeyResult(ListBitLockerKeyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListBitLockerKeyResult(
            value=self.value)


def list_bit_locker_key(job_name: Optional[str] = None,
                        resource_group_name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListBitLockerKeyResult:
    """
    Returns the BitLocker Keys for all drives in the specified job.

    Uses Azure REST API version 2021-01-01.


    :param str job_name: The name of the import/export job.
    :param str resource_group_name: The resource group name uniquely identifies the resource group within the user subscription.
    """
    __args__ = dict()
    __args__['jobName'] = job_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:importexport:listBitLockerKey', __args__, opts=opts, typ=ListBitLockerKeyResult).value

    return AwaitableListBitLockerKeyResult(
        value=pulumi.get(__ret__, 'value'))
def list_bit_locker_key_output(job_name: Optional[pulumi.Input[str]] = None,
                               resource_group_name: Optional[pulumi.Input[str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListBitLockerKeyResult]:
    """
    Returns the BitLocker Keys for all drives in the specified job.

    Uses Azure REST API version 2021-01-01.


    :param str job_name: The name of the import/export job.
    :param str resource_group_name: The resource group name uniquely identifies the resource group within the user subscription.
    """
    __args__ = dict()
    __args__['jobName'] = job_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:importexport:listBitLockerKey', __args__, opts=opts, typ=ListBitLockerKeyResult)
    return __ret__.apply(lambda __response__: ListBitLockerKeyResult(
        value=pulumi.get(__response__, 'value')))
