# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListAssetStreamingLocatorsResult',
    'AwaitableListAssetStreamingLocatorsResult',
    'list_asset_streaming_locators',
    'list_asset_streaming_locators_output',
]

@pulumi.output_type
class ListAssetStreamingLocatorsResult:
    """
    The Streaming Locators associated with this Asset.
    """
    def __init__(__self__, streaming_locators=None):
        if streaming_locators and not isinstance(streaming_locators, list):
            raise TypeError("Expected argument 'streaming_locators' to be a list")
        pulumi.set(__self__, "streaming_locators", streaming_locators)

    @property
    @pulumi.getter(name="streamingLocators")
    def streaming_locators(self) -> Sequence['outputs.AssetStreamingLocatorResponse']:
        """
        The list of Streaming Locators.
        """
        return pulumi.get(self, "streaming_locators")


class AwaitableListAssetStreamingLocatorsResult(ListAssetStreamingLocatorsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAssetStreamingLocatorsResult(
            streaming_locators=self.streaming_locators)


def list_asset_streaming_locators(account_name: Optional[str] = None,
                                  asset_name: Optional[str] = None,
                                  resource_group_name: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAssetStreamingLocatorsResult:
    """
    Lists Streaming Locators which are associated with this asset.

    Uses Azure REST API version 2023-01-01.

    Other available API versions: 2018-07-01, 2020-05-01, 2021-06-01, 2021-11-01, 2022-08-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native media [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str account_name: The Media Services account name.
    :param str asset_name: The Asset name.
    :param str resource_group_name: The name of the resource group within the Azure subscription.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['assetName'] = asset_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:media:listAssetStreamingLocators', __args__, opts=opts, typ=ListAssetStreamingLocatorsResult).value

    return AwaitableListAssetStreamingLocatorsResult(
        streaming_locators=pulumi.get(__ret__, 'streaming_locators'))
def list_asset_streaming_locators_output(account_name: Optional[pulumi.Input[str]] = None,
                                         asset_name: Optional[pulumi.Input[str]] = None,
                                         resource_group_name: Optional[pulumi.Input[str]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAssetStreamingLocatorsResult]:
    """
    Lists Streaming Locators which are associated with this asset.

    Uses Azure REST API version 2023-01-01.

    Other available API versions: 2018-07-01, 2020-05-01, 2021-06-01, 2021-11-01, 2022-08-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native media [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str account_name: The Media Services account name.
    :param str asset_name: The Asset name.
    :param str resource_group_name: The name of the resource group within the Azure subscription.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['assetName'] = asset_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:media:listAssetStreamingLocators', __args__, opts=opts, typ=ListAssetStreamingLocatorsResult)
    return __ret__.apply(lambda __response__: ListAssetStreamingLocatorsResult(
        streaming_locators=pulumi.get(__response__, 'streaming_locators')))
