# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccessMode',
    'ComparisonOperationType',
    'ConditionOperator',
    'CriterionType',
    'DimensionOperator',
    'ExporterType',
    'ExtendedLocationType',
    'ExternalNetworkingMode',
    'IdentityType',
    'IncidentManagementService',
    'JsonMapperElement',
    'Kind',
    'ManagedServiceIdentityType',
    'MetricStatisticType',
    'OperationType',
    'PipelineType',
    'PredictiveAutoscalePolicyScaleMode',
    'PrivateEndpointServiceConnectionStatus',
    'ProcessorType',
    'ReceiverType',
    'RecurrenceFrequency',
    'ScaleDirection',
    'ScaleRuleMetricDimensionOperationType',
    'ScaleType',
    'ScopedResourceKind',
    'StreamEncodingType',
    'SyslogProtocol',
    'TimeAggregation',
    'TimeAggregationType',
]


class AccessMode(str, Enum):
    """
    Specifies the default access mode of queries through associated private endpoints in scope. If not specified default value is 'Open'. You can override this default setting for a specific private endpoint connection by adding an exclusion in the 'exclusions' array.
    """
    OPEN = "Open"
    PRIVATE_ONLY = "PrivateOnly"


class ComparisonOperationType(str, Enum):
    """
    the operator that is used to compare the metric data and the threshold.
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"


class ConditionOperator(str, Enum):
    """
    The criteria operator. Relevant and required only for rules of the kind LogAlert.
    """
    EQUALS = "Equals"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_OR_LESS_THAN = "GreaterOrLessThan"


class CriterionType(str, Enum):
    """
    Specifies the type of threshold criteria
    """
    STATIC_THRESHOLD_CRITERION = "StaticThresholdCriterion"
    DYNAMIC_THRESHOLD_CRITERION = "DynamicThresholdCriterion"


class DimensionOperator(str, Enum):
    """
    Operator for dimension values
    """
    INCLUDE = "Include"
    EXCLUDE = "Exclude"


class ExporterType(str, Enum):
    """
    The type of exporter.
    """
    AZURE_MONITOR_WORKSPACE_LOGS = "AzureMonitorWorkspaceLogs"
    """
    Export logs to Azure Monitor Workspace.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Export data to another pipeline group instance.
    """


class ExtendedLocationType(str, Enum):
    """
    The type of the extended location.
    """
    EDGE_ZONE = "EdgeZone"
    """
    Azure Edge Zones location type
    """
    CUSTOM_LOCATION = "CustomLocation"
    """
    Azure Custom Locations type
    """


class ExternalNetworkingMode(str, Enum):
    """
    External networking mode.
    """
    LOAD_BALANCER_ONLY = "LoadBalancerOnly"
    """
    Load balancer only.
    """


class IdentityType(str, Enum):
    """
    Type of managed service identity.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    NONE = "None"


class IncidentManagementService(str, Enum):
    """
    The incident management service type
    """
    ICM = "Icm"


class JsonMapperElement(str, Enum):
    """
    Define the destination's element. The element is the body or the attributes of the message, to which the json array mapper will write the output map.
    """
    BODY = "body"
    """
    Read or write the json array from or to the body of the message.
    """
    ATTRIBUTES = "attributes"
    """
    Read or write the json array from or to the attributes of the message.
    """


class Kind(str, Enum):
    """
    Indicates the type of scheduled query rule. The default is LogAlert.
    """
    LOG_ALERT = "LogAlert"
    EVENT_LOG_ALERT = "EventLogAlert"
    LOG_TO_METRIC = "LogToMetric"


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class MetricStatisticType(str, Enum):
    """
    the metric statistic type. How the metrics from multiple instances are combined.
    """
    AVERAGE = "Average"
    MIN = "Min"
    MAX = "Max"
    SUM = "Sum"
    COUNT = "Count"


class OperationType(str, Enum):
    """
    the operation associated with the notification and its value must be "scale"
    """
    SCALE = "Scale"


class PipelineType(str, Enum):
    """
    The type of pipeline
    """
    LOGS = "Logs"
    """
    Pipeline for logs telemetry.
    """


class PredictiveAutoscalePolicyScaleMode(str, Enum):
    """
    the predictive autoscale mode
    """
    DISABLED = "Disabled"
    FORECAST_ONLY = "ForecastOnly"
    ENABLED = "Enabled"


class PrivateEndpointServiceConnectionStatus(str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


class ProcessorType(str, Enum):
    """
    The type of processor.
    """
    BATCH = "Batch"
    """
    Batch processor.
    """


class ReceiverType(str, Enum):
    """
    The type of receiver.
    """
    SYSLOG = "Syslog"
    """
    Linux syslog.
    """
    AMA = "Ama"
    """
    Receives data from azure monitor agent receiver.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Receives data from another pipeline group.
    """
    OTLP = "OTLP"
    """
    Receives data from a OTLP collector.
    """
    UDP = "UDP"
    """
    Receives data from an UDP collector.
    """


class RecurrenceFrequency(str, Enum):
    """
    the recurrence frequency. How often the schedule profile should take effect. This value must be Week, meaning each week will have the same set of profiles. For example, to set a daily schedule, set **schedule** to every day of the week. The frequency property specifies that the schedule is repeated weekly.
    """
    NONE = "None"
    SECOND = "Second"
    MINUTE = "Minute"
    HOUR = "Hour"
    DAY = "Day"
    WEEK = "Week"
    MONTH = "Month"
    YEAR = "Year"


class ScaleDirection(str, Enum):
    """
    the scale direction. Whether the scaling action increases or decreases the number of instances.
    """
    NONE = "None"
    INCREASE = "Increase"
    DECREASE = "Decrease"


class ScaleRuleMetricDimensionOperationType(str, Enum):
    """
    the dimension operator. Only 'Equals' and 'NotEquals' are supported. 'Equals' being equal to any of the values. 'NotEquals' being not equal to all of the values
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"


class ScaleType(str, Enum):
    """
    the type of action that should occur when the scale rule fires.
    """
    CHANGE_COUNT = "ChangeCount"
    PERCENT_CHANGE_COUNT = "PercentChangeCount"
    EXACT_COUNT = "ExactCount"
    SERVICE_ALLOWED_NEXT_VALUE = "ServiceAllowedNextValue"


class ScopedResourceKind(str, Enum):
    """
    The kind of scoped Azure monitor resource.
    """
    RESOURCE = "Resource"
    METRICS = "Metrics"


class StreamEncodingType(str, Enum):
    """
    The encoding of the stream being received.
    """
    NOP = "nop"
    """
    No encoding validation. Treats the file as a stream of raw bytes.
    """
    UTF_8 = "utf-8"
    """
    UTF-8 encoding.
    """
    UTF_16LE = "utf-16le"
    """
    UTF-16 encoding with little-endian byte order.
    """
    UTF_16BE = "utf-16be"
    """
    UTF-16 encoding with little-endian byte order.
    """
    ASCII = "ascii"
    """
    ASCII encoding.
    """
    BIG5 = "big5"
    """
    The Big5 Chinese character encoding.
    """


class SyslogProtocol(str, Enum):
    """
    Protocol to parse syslog messages. Default rfc3164
    """
    RFC3164 = "rfc3164"
    """
    rfc3164 protocol.
    """
    RFC5424 = "rfc5424"
    """
    rfc5424 protocol.
    """


class TimeAggregation(str, Enum):
    """
    Aggregation type. Relevant and required only for rules of the kind LogAlert.
    """
    COUNT = "Count"
    AVERAGE = "Average"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    TOTAL = "Total"


class TimeAggregationType(str, Enum):
    """
    time aggregation type. How the data that is collected should be combined over time. The default value is Average.
    """
    AVERAGE = "Average"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    TOTAL = "Total"
    COUNT = "Count"
    LAST = "Last"
