# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListOpenShiftClusterAdminCredentialsResult',
    'AwaitableListOpenShiftClusterAdminCredentialsResult',
    'list_open_shift_cluster_admin_credentials',
    'list_open_shift_cluster_admin_credentials_output',
]

@pulumi.output_type
class ListOpenShiftClusterAdminCredentialsResult:
    """
    OpenShiftClusterAdminKubeconfig represents an OpenShift cluster's admin kubeconfig.
    """
    def __init__(__self__, kubeconfig=None):
        if kubeconfig and not isinstance(kubeconfig, str):
            raise TypeError("Expected argument 'kubeconfig' to be a str")
        pulumi.set(__self__, "kubeconfig", kubeconfig)

    @property
    @pulumi.getter
    def kubeconfig(self) -> Optional[str]:
        """
        The base64-encoded kubeconfig file.
        """
        return pulumi.get(self, "kubeconfig")


class AwaitableListOpenShiftClusterAdminCredentialsResult(ListOpenShiftClusterAdminCredentialsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListOpenShiftClusterAdminCredentialsResult(
            kubeconfig=self.kubeconfig)


def list_open_shift_cluster_admin_credentials(resource_group_name: Optional[str] = None,
                                              resource_name: Optional[str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListOpenShiftClusterAdminCredentialsResult:
    """
    The operation returns the admin kubeconfig.

    Uses Azure REST API version 2023-11-22.

    Other available API versions: 2022-09-04, 2023-04-01, 2023-07-01-preview, 2023-09-04, 2024-08-12-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native redhatopenshift [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str resource_name: The name of the OpenShift cluster resource.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:redhatopenshift:listOpenShiftClusterAdminCredentials', __args__, opts=opts, typ=ListOpenShiftClusterAdminCredentialsResult).value

    return AwaitableListOpenShiftClusterAdminCredentialsResult(
        kubeconfig=pulumi.get(__ret__, 'kubeconfig'))
def list_open_shift_cluster_admin_credentials_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                                                     resource_name: Optional[pulumi.Input[str]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListOpenShiftClusterAdminCredentialsResult]:
    """
    The operation returns the admin kubeconfig.

    Uses Azure REST API version 2023-11-22.

    Other available API versions: 2022-09-04, 2023-04-01, 2023-07-01-preview, 2023-09-04, 2024-08-12-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native redhatopenshift [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str resource_name: The name of the OpenShift cluster resource.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:redhatopenshift:listOpenShiftClusterAdminCredentials', __args__, opts=opts, typ=ListOpenShiftClusterAdminCredentialsResult)
    return __ret__.apply(lambda __response__: ListOpenShiftClusterAdminCredentialsResult(
        kubeconfig=pulumi.get(__response__, 'kubeconfig')))
