# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['SecurityContactArgs', 'SecurityContact']

@pulumi.input_type
class SecurityContactArgs:
    def __init__(__self__, *,
                 emails: Optional[pulumi.Input[str]] = None,
                 is_enabled: Optional[pulumi.Input[bool]] = None,
                 notifications_by_role: Optional[pulumi.Input['SecurityContactPropertiesNotificationsByRoleArgs']] = None,
                 notifications_sources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAttackPathArgs']]]]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 security_contact_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SecurityContact resource.
        :param pulumi.Input[str] emails: List of email addresses which will get notifications from Microsoft Defender for Cloud by the configurations defined in this security contact.
        :param pulumi.Input[bool] is_enabled: Indicates whether the security contact is enabled.
        :param pulumi.Input['SecurityContactPropertiesNotificationsByRoleArgs'] notifications_by_role: Defines whether to send email notifications from Microsoft Defender for Cloud to persons with specific RBAC roles on the subscription.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAttackPathArgs']]]] notifications_sources: A collection of sources types which evaluate the email notification.
        :param pulumi.Input[str] phone: The security contact's phone number
        :param pulumi.Input[str] security_contact_name: Name of the security contact object
        """
        if emails is not None:
            pulumi.set(__self__, "emails", emails)
        if is_enabled is not None:
            pulumi.set(__self__, "is_enabled", is_enabled)
        if notifications_by_role is not None:
            pulumi.set(__self__, "notifications_by_role", notifications_by_role)
        if notifications_sources is not None:
            pulumi.set(__self__, "notifications_sources", notifications_sources)
        if phone is not None:
            pulumi.set(__self__, "phone", phone)
        if security_contact_name is not None:
            pulumi.set(__self__, "security_contact_name", security_contact_name)

    @property
    @pulumi.getter
    def emails(self) -> Optional[pulumi.Input[str]]:
        """
        List of email addresses which will get notifications from Microsoft Defender for Cloud by the configurations defined in this security contact.
        """
        return pulumi.get(self, "emails")

    @emails.setter
    def emails(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "emails", value)

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the security contact is enabled.
        """
        return pulumi.get(self, "is_enabled")

    @is_enabled.setter
    def is_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_enabled", value)

    @property
    @pulumi.getter(name="notificationsByRole")
    def notifications_by_role(self) -> Optional[pulumi.Input['SecurityContactPropertiesNotificationsByRoleArgs']]:
        """
        Defines whether to send email notifications from Microsoft Defender for Cloud to persons with specific RBAC roles on the subscription.
        """
        return pulumi.get(self, "notifications_by_role")

    @notifications_by_role.setter
    def notifications_by_role(self, value: Optional[pulumi.Input['SecurityContactPropertiesNotificationsByRoleArgs']]):
        pulumi.set(self, "notifications_by_role", value)

    @property
    @pulumi.getter(name="notificationsSources")
    def notifications_sources(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAttackPathArgs']]]]]:
        """
        A collection of sources types which evaluate the email notification.
        """
        return pulumi.get(self, "notifications_sources")

    @notifications_sources.setter
    def notifications_sources(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAttackPathArgs']]]]]):
        pulumi.set(self, "notifications_sources", value)

    @property
    @pulumi.getter
    def phone(self) -> Optional[pulumi.Input[str]]:
        """
        The security contact's phone number
        """
        return pulumi.get(self, "phone")

    @phone.setter
    def phone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "phone", value)

    @property
    @pulumi.getter(name="securityContactName")
    def security_contact_name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the security contact object
        """
        return pulumi.get(self, "security_contact_name")

    @security_contact_name.setter
    def security_contact_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_contact_name", value)


class SecurityContact(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 emails: Optional[pulumi.Input[str]] = None,
                 is_enabled: Optional[pulumi.Input[bool]] = None,
                 notifications_by_role: Optional[pulumi.Input[Union['SecurityContactPropertiesNotificationsByRoleArgs', 'SecurityContactPropertiesNotificationsByRoleArgsDict']]] = None,
                 notifications_sources: Optional[pulumi.Input[Sequence[pulumi.Input[Union[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAlertArgsDict'], Union['NotificationsSourceAttackPathArgs', 'NotificationsSourceAttackPathArgsDict']]]]]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 security_contact_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Contact details and configurations for notifications coming from Microsoft Defender for Cloud.

        Uses Azure REST API version 2023-12-01-preview. In version 2.x of the Azure Native provider, it used API version 2020-01-01-preview.

        Other available API versions: 2017-08-01-preview, 2020-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native security [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] emails: List of email addresses which will get notifications from Microsoft Defender for Cloud by the configurations defined in this security contact.
        :param pulumi.Input[bool] is_enabled: Indicates whether the security contact is enabled.
        :param pulumi.Input[Union['SecurityContactPropertiesNotificationsByRoleArgs', 'SecurityContactPropertiesNotificationsByRoleArgsDict']] notifications_by_role: Defines whether to send email notifications from Microsoft Defender for Cloud to persons with specific RBAC roles on the subscription.
        :param pulumi.Input[Sequence[pulumi.Input[Union[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAlertArgsDict'], Union['NotificationsSourceAttackPathArgs', 'NotificationsSourceAttackPathArgsDict']]]]] notifications_sources: A collection of sources types which evaluate the email notification.
        :param pulumi.Input[str] phone: The security contact's phone number
        :param pulumi.Input[str] security_contact_name: Name of the security contact object
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[SecurityContactArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Contact details and configurations for notifications coming from Microsoft Defender for Cloud.

        Uses Azure REST API version 2023-12-01-preview. In version 2.x of the Azure Native provider, it used API version 2020-01-01-preview.

        Other available API versions: 2017-08-01-preview, 2020-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native security [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param SecurityContactArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecurityContactArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 emails: Optional[pulumi.Input[str]] = None,
                 is_enabled: Optional[pulumi.Input[bool]] = None,
                 notifications_by_role: Optional[pulumi.Input[Union['SecurityContactPropertiesNotificationsByRoleArgs', 'SecurityContactPropertiesNotificationsByRoleArgsDict']]] = None,
                 notifications_sources: Optional[pulumi.Input[Sequence[pulumi.Input[Union[Union['NotificationsSourceAlertArgs', 'NotificationsSourceAlertArgsDict'], Union['NotificationsSourceAttackPathArgs', 'NotificationsSourceAttackPathArgsDict']]]]]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 security_contact_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecurityContactArgs.__new__(SecurityContactArgs)

            __props__.__dict__["emails"] = emails
            __props__.__dict__["is_enabled"] = is_enabled
            __props__.__dict__["notifications_by_role"] = notifications_by_role
            __props__.__dict__["notifications_sources"] = notifications_sources
            __props__.__dict__["phone"] = phone
            __props__.__dict__["security_contact_name"] = security_contact_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:security/v20170801preview:SecurityContact"), pulumi.Alias(type_="azure-native:security/v20200101preview:SecurityContact"), pulumi.Alias(type_="azure-native:security/v20231201preview:SecurityContact")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(SecurityContact, __self__).__init__(
            'azure-native:security:SecurityContact',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'SecurityContact':
        """
        Get an existing SecurityContact resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = SecurityContactArgs.__new__(SecurityContactArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["emails"] = None
        __props__.__dict__["is_enabled"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["notifications_by_role"] = None
        __props__.__dict__["notifications_sources"] = None
        __props__.__dict__["phone"] = None
        __props__.__dict__["type"] = None
        return SecurityContact(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def emails(self) -> pulumi.Output[Optional[str]]:
        """
        List of email addresses which will get notifications from Microsoft Defender for Cloud by the configurations defined in this security contact.
        """
        return pulumi.get(self, "emails")

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates whether the security contact is enabled.
        """
        return pulumi.get(self, "is_enabled")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Resource name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="notificationsByRole")
    def notifications_by_role(self) -> pulumi.Output[Optional['outputs.SecurityContactPropertiesResponseNotificationsByRole']]:
        """
        Defines whether to send email notifications from Microsoft Defender for Cloud to persons with specific RBAC roles on the subscription.
        """
        return pulumi.get(self, "notifications_by_role")

    @property
    @pulumi.getter(name="notificationsSources")
    def notifications_sources(self) -> pulumi.Output[Optional[Sequence[Any]]]:
        """
        A collection of sources types which evaluate the email notification.
        """
        return pulumi.get(self, "notifications_sources")

    @property
    @pulumi.getter
    def phone(self) -> pulumi.Output[Optional[str]]:
        """
        The security contact's phone number
        """
        return pulumi.get(self, "phone")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Resource type
        """
        return pulumi.get(self, "type")

