# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListNodeTypeFaultSimulationResult',
    'AwaitableListNodeTypeFaultSimulationResult',
    'list_node_type_fault_simulation',
    'list_node_type_fault_simulation_output',
]

@pulumi.output_type
class ListNodeTypeFaultSimulationResult:
    """
    Fault simulation list results
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[str]:
        """
        The link to the next page of items
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Sequence['outputs.FaultSimulationResponse']:
        """
        The FaultSimulation items on this page
        """
        return pulumi.get(self, "value")


class AwaitableListNodeTypeFaultSimulationResult(ListNodeTypeFaultSimulationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListNodeTypeFaultSimulationResult(
            next_link=self.next_link,
            value=self.value)


def list_node_type_fault_simulation(cluster_name: Optional[str] = None,
                                    node_type_name: Optional[str] = None,
                                    resource_group_name: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListNodeTypeFaultSimulationResult:
    """
    Gets the list of recent fault simulations for the node type.

    Uses Azure REST API version 2024-11-01-preview.


    :param str cluster_name: The name of the cluster resource.
    :param str node_type_name: The name of the node type.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['nodeTypeName'] = node_type_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:servicefabric:listNodeTypeFaultSimulation', __args__, opts=opts, typ=ListNodeTypeFaultSimulationResult).value

    return AwaitableListNodeTypeFaultSimulationResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_node_type_fault_simulation_output(cluster_name: Optional[pulumi.Input[str]] = None,
                                           node_type_name: Optional[pulumi.Input[str]] = None,
                                           resource_group_name: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListNodeTypeFaultSimulationResult]:
    """
    Gets the list of recent fault simulations for the node type.

    Uses Azure REST API version 2024-11-01-preview.


    :param str cluster_name: The name of the cluster resource.
    :param str node_type_name: The name of the node type.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['nodeTypeName'] = node_type_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:servicefabric:listNodeTypeFaultSimulation', __args__, opts=opts, typ=ListNodeTypeFaultSimulationResult)
    return __ret__.apply(lambda __response__: ListNodeTypeFaultSimulationResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
