# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['LandingZoneConfigurationOperationArgs', 'LandingZoneConfigurationOperation']

@pulumi.input_type
class LandingZoneConfigurationOperationArgs:
    def __init__(__self__, *,
                 landing_zone_account_name: pulumi.Input[str],
                 resource_group_name: pulumi.Input[str],
                 landing_zone_configuration_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input['LandingZoneConfigurationResourcePropertiesArgs']] = None):
        """
        The set of arguments for constructing a LandingZoneConfigurationOperation resource.
        :param pulumi.Input[str] landing_zone_account_name: The landing zone account.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[str] landing_zone_configuration_name: The landing zone configuration name
        :param pulumi.Input['LandingZoneConfigurationResourcePropertiesArgs'] properties: The resource-specific properties for this resource.
        """
        pulumi.set(__self__, "landing_zone_account_name", landing_zone_account_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if landing_zone_configuration_name is not None:
            pulumi.set(__self__, "landing_zone_configuration_name", landing_zone_configuration_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter(name="landingZoneAccountName")
    def landing_zone_account_name(self) -> pulumi.Input[str]:
        """
        The landing zone account.
        """
        return pulumi.get(self, "landing_zone_account_name")

    @landing_zone_account_name.setter
    def landing_zone_account_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "landing_zone_account_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="landingZoneConfigurationName")
    def landing_zone_configuration_name(self) -> Optional[pulumi.Input[str]]:
        """
        The landing zone configuration name
        """
        return pulumi.get(self, "landing_zone_configuration_name")

    @landing_zone_configuration_name.setter
    def landing_zone_configuration_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "landing_zone_configuration_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['LandingZoneConfigurationResourcePropertiesArgs']]:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['LandingZoneConfigurationResourcePropertiesArgs']]):
        pulumi.set(self, "properties", value)


class LandingZoneConfigurationOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 landing_zone_account_name: Optional[pulumi.Input[str]] = None,
                 landing_zone_configuration_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[Union['LandingZoneConfigurationResourcePropertiesArgs', 'LandingZoneConfigurationResourcePropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Concrete proxy resource types can be created by aliasing this type using a specific property type.

        Uses Azure REST API version 2025-02-27-preview. In version 2.x of the Azure Native provider, it used API version 2025-02-27-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] landing_zone_account_name: The landing zone account.
        :param pulumi.Input[str] landing_zone_configuration_name: The landing zone configuration name
        :param pulumi.Input[Union['LandingZoneConfigurationResourcePropertiesArgs', 'LandingZoneConfigurationResourcePropertiesArgsDict']] properties: The resource-specific properties for this resource.
        :param pulumi.Input[str] resource_group_name: The name of the resource group. The name is case insensitive.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: LandingZoneConfigurationOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Concrete proxy resource types can be created by aliasing this type using a specific property type.

        Uses Azure REST API version 2025-02-27-preview. In version 2.x of the Azure Native provider, it used API version 2025-02-27-preview.

        :param str resource_name: The name of the resource.
        :param LandingZoneConfigurationOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(LandingZoneConfigurationOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 landing_zone_account_name: Optional[pulumi.Input[str]] = None,
                 landing_zone_configuration_name: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[Union['LandingZoneConfigurationResourcePropertiesArgs', 'LandingZoneConfigurationResourcePropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = LandingZoneConfigurationOperationArgs.__new__(LandingZoneConfigurationOperationArgs)

            if landing_zone_account_name is None and not opts.urn:
                raise TypeError("Missing required property 'landing_zone_account_name'")
            __props__.__dict__["landing_zone_account_name"] = landing_zone_account_name
            __props__.__dict__["landing_zone_configuration_name"] = landing_zone_configuration_name
            __props__.__dict__["properties"] = properties
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:sovereign/v20250227preview:LandingZoneConfigurationOperation")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(LandingZoneConfigurationOperation, __self__).__init__(
            'azure-native:sovereign:LandingZoneConfigurationOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'LandingZoneConfigurationOperation':
        """
        Get an existing LandingZoneConfigurationOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = LandingZoneConfigurationOperationArgs.__new__(LandingZoneConfigurationOperationArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return LandingZoneConfigurationOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.LandingZoneConfigurationResourcePropertiesResponse']:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

