# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'ListConnectionConsentLinksResult',
    'AwaitableListConnectionConsentLinksResult',
    'list_connection_consent_links',
    'list_connection_consent_links_output',
]

@pulumi.output_type
class ListConnectionConsentLinksResult:
    """
    Collection of consent links
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.ConsentLinkDefinitionResponse']]:
        """
        Collection of resources
        """
        return pulumi.get(self, "value")


class AwaitableListConnectionConsentLinksResult(ListConnectionConsentLinksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListConnectionConsentLinksResult(
            value=self.value)


def list_connection_consent_links(connection_name: Optional[str] = None,
                                  parameters: Optional[Sequence[Union['ConsentLinkParameterDefinition', 'ConsentLinkParameterDefinitionDict']]] = None,
                                  resource_group_name: Optional[str] = None,
                                  subscription_id: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListConnectionConsentLinksResult:
    """
    Lists the consent links of a connection

    Uses Azure REST API version 2016-06-01.

    Other available API versions: 2015-08-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native web [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str connection_name: Connection name
    :param Sequence[Union['ConsentLinkParameterDefinition', 'ConsentLinkParameterDefinitionDict']] parameters: Collection of resources
    :param str resource_group_name: The resource group
    :param str subscription_id: Subscription Id
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['parameters'] = parameters
    __args__['resourceGroupName'] = resource_group_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:web:listConnectionConsentLinks', __args__, opts=opts, typ=ListConnectionConsentLinksResult).value

    return AwaitableListConnectionConsentLinksResult(
        value=pulumi.get(__ret__, 'value'))
def list_connection_consent_links_output(connection_name: Optional[pulumi.Input[str]] = None,
                                         parameters: Optional[pulumi.Input[Optional[Sequence[Union['ConsentLinkParameterDefinition', 'ConsentLinkParameterDefinitionDict']]]]] = None,
                                         resource_group_name: Optional[pulumi.Input[str]] = None,
                                         subscription_id: Optional[pulumi.Input[Optional[str]]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListConnectionConsentLinksResult]:
    """
    Lists the consent links of a connection

    Uses Azure REST API version 2016-06-01.

    Other available API versions: 2015-08-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native web [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str connection_name: Connection name
    :param Sequence[Union['ConsentLinkParameterDefinition', 'ConsentLinkParameterDefinitionDict']] parameters: Collection of resources
    :param str resource_group_name: The resource group
    :param str subscription_id: Subscription Id
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['parameters'] = parameters
    __args__['resourceGroupName'] = resource_group_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:web:listConnectionConsentLinks', __args__, opts=opts, typ=ListConnectionConsentLinksResult)
    return __ret__.apply(lambda __response__: ListConnectionConsentLinksResult(
        value=pulumi.get(__response__, 'value')))
