# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult',
    'AwaitableGetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult',
    'get_managed_database_vulnerability_assessment_rule_baseline',
    'get_managed_database_vulnerability_assessment_rule_baseline_output',
]

@pulumi.output_type
class GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult:
    """
    A database vulnerability assessment rule baseline.
    """
    def __init__(__self__, azure_api_version=None, baseline_results=None, id=None, name=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if baseline_results and not isinstance(baseline_results, list):
            raise TypeError("Expected argument 'baseline_results' to be a list")
        pulumi.set(__self__, "baseline_results", baseline_results)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="baselineResults")
    def baseline_results(self) -> Sequence['outputs.DatabaseVulnerabilityAssessmentRuleBaselineItemResponse']:
        """
        The rule baseline result
        """
        return pulumi.get(self, "baseline_results")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult(GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult(
            azure_api_version=self.azure_api_version,
            baseline_results=self.baseline_results,
            id=self.id,
            name=self.name,
            type=self.type)


def get_managed_database_vulnerability_assessment_rule_baseline(baseline_name: Optional[str] = None,
                                                                database_name: Optional[str] = None,
                                                                managed_instance_name: Optional[str] = None,
                                                                resource_group_name: Optional[str] = None,
                                                                rule_id: Optional[str] = None,
                                                                vulnerability_assessment_name: Optional[str] = None,
                                                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult:
    """
    Gets a database's vulnerability assessment rule baseline.

    Uses Azure REST API version 2023-08-01.

    Other available API versions: 2017-10-01-preview, 2020-02-02-preview, 2020-08-01-preview, 2020-11-01-preview, 2021-02-01-preview, 2021-05-01-preview, 2021-08-01-preview, 2021-11-01, 2021-11-01-preview, 2022-02-01-preview, 2022-05-01-preview, 2022-08-01-preview, 2022-11-01-preview, 2023-02-01-preview, 2023-05-01-preview, 2023-08-01-preview, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native sql [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str baseline_name: The name of the vulnerability assessment rule baseline (default implies a baseline on a database level rule and master for server level rule).
    :param str database_name: The name of the database for which the vulnerability assessment rule baseline is defined.
    :param str managed_instance_name: The name of the managed instance.
    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str rule_id: The vulnerability assessment rule ID.
    :param str vulnerability_assessment_name: The name of the vulnerability assessment.
    """
    __args__ = dict()
    __args__['baselineName'] = baseline_name
    __args__['databaseName'] = database_name
    __args__['managedInstanceName'] = managed_instance_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleId'] = rule_id
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:sql:getManagedDatabaseVulnerabilityAssessmentRuleBaseline', __args__, opts=opts, typ=GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult).value

    return AwaitableGetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        baseline_results=pulumi.get(__ret__, 'baseline_results'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        type=pulumi.get(__ret__, 'type'))
def get_managed_database_vulnerability_assessment_rule_baseline_output(baseline_name: Optional[pulumi.Input[str]] = None,
                                                                       database_name: Optional[pulumi.Input[str]] = None,
                                                                       managed_instance_name: Optional[pulumi.Input[str]] = None,
                                                                       resource_group_name: Optional[pulumi.Input[str]] = None,
                                                                       rule_id: Optional[pulumi.Input[str]] = None,
                                                                       vulnerability_assessment_name: Optional[pulumi.Input[str]] = None,
                                                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult]:
    """
    Gets a database's vulnerability assessment rule baseline.

    Uses Azure REST API version 2023-08-01.

    Other available API versions: 2017-10-01-preview, 2020-02-02-preview, 2020-08-01-preview, 2020-11-01-preview, 2021-02-01-preview, 2021-05-01-preview, 2021-08-01-preview, 2021-11-01, 2021-11-01-preview, 2022-02-01-preview, 2022-05-01-preview, 2022-08-01-preview, 2022-11-01-preview, 2023-02-01-preview, 2023-05-01-preview, 2023-08-01-preview, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native sql [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str baseline_name: The name of the vulnerability assessment rule baseline (default implies a baseline on a database level rule and master for server level rule).
    :param str database_name: The name of the database for which the vulnerability assessment rule baseline is defined.
    :param str managed_instance_name: The name of the managed instance.
    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str rule_id: The vulnerability assessment rule ID.
    :param str vulnerability_assessment_name: The name of the vulnerability assessment.
    """
    __args__ = dict()
    __args__['baselineName'] = baseline_name
    __args__['databaseName'] = database_name
    __args__['managedInstanceName'] = managed_instance_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleId'] = rule_id
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:sql:getManagedDatabaseVulnerabilityAssessmentRuleBaseline', __args__, opts=opts, typ=GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult)
    return __ret__.apply(lambda __response__: GetManagedDatabaseVulnerabilityAssessmentRuleBaselineResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        baseline_results=pulumi.get(__response__, 'baseline_results'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        type=pulumi.get(__response__, 'type')))
