# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult',
    'AwaitableGetWorkspaceManagedSqlServerVulnerabilityAssessmentResult',
    'get_workspace_managed_sql_server_vulnerability_assessment',
    'get_workspace_managed_sql_server_vulnerability_assessment_output',
]

@pulumi.output_type
class GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult:
    """
    A server vulnerability assessment.
    """
    def __init__(__self__, azure_api_version=None, id=None, name=None, recurring_scans=None, storage_container_path=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if recurring_scans and not isinstance(recurring_scans, dict):
            raise TypeError("Expected argument 'recurring_scans' to be a dict")
        pulumi.set(__self__, "recurring_scans", recurring_scans)
        if storage_container_path and not isinstance(storage_container_path, str):
            raise TypeError("Expected argument 'storage_container_path' to be a str")
        pulumi.set(__self__, "storage_container_path", storage_container_path)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="recurringScans")
    def recurring_scans(self) -> Optional['outputs.VulnerabilityAssessmentRecurringScansPropertiesResponse']:
        """
        The recurring scans settings
        """
        return pulumi.get(self, "recurring_scans")

    @property
    @pulumi.getter(name="storageContainerPath")
    def storage_container_path(self) -> str:
        """
        A blob storage container path to hold the scan results (e.g. https://myStorage.blob.core.windows.net/VaScans/).
        """
        return pulumi.get(self, "storage_container_path")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetWorkspaceManagedSqlServerVulnerabilityAssessmentResult(GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            recurring_scans=self.recurring_scans,
            storage_container_path=self.storage_container_path,
            type=self.type)


def get_workspace_managed_sql_server_vulnerability_assessment(resource_group_name: Optional[str] = None,
                                                              vulnerability_assessment_name: Optional[str] = None,
                                                              workspace_name: Optional[str] = None,
                                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkspaceManagedSqlServerVulnerabilityAssessmentResult:
    """
    Get workspace managed sql server's vulnerability assessment.

    Uses Azure REST API version 2021-06-01.

    Other available API versions: 2021-04-01-preview, 2021-05-01, 2021-06-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native synapse [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str vulnerability_assessment_name: The name of the vulnerability assessment.
    :param str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:synapse:getWorkspaceManagedSqlServerVulnerabilityAssessment', __args__, opts=opts, typ=GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult).value

    return AwaitableGetWorkspaceManagedSqlServerVulnerabilityAssessmentResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        recurring_scans=pulumi.get(__ret__, 'recurring_scans'),
        storage_container_path=pulumi.get(__ret__, 'storage_container_path'),
        type=pulumi.get(__ret__, 'type'))
def get_workspace_managed_sql_server_vulnerability_assessment_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                                                                     vulnerability_assessment_name: Optional[pulumi.Input[str]] = None,
                                                                     workspace_name: Optional[pulumi.Input[str]] = None,
                                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult]:
    """
    Get workspace managed sql server's vulnerability assessment.

    Uses Azure REST API version 2021-06-01.

    Other available API versions: 2021-04-01-preview, 2021-05-01, 2021-06-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native synapse [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str vulnerability_assessment_name: The name of the vulnerability assessment.
    :param str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:synapse:getWorkspaceManagedSqlServerVulnerabilityAssessment', __args__, opts=opts, typ=GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult)
    return __ret__.apply(lambda __response__: GetWorkspaceManagedSqlServerVulnerabilityAssessmentResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        recurring_scans=pulumi.get(__response__, 'recurring_scans'),
        storage_container_path=pulumi.get(__response__, 'storage_container_path'),
        type=pulumi.get(__response__, 'type')))
